﻿'Imports System.Drawing
Imports System.IO ' pour lecture eciture fichiers

Public Class Main

    
    Structure manualStructure
        Public used As Boolean ' indique si utilisé
        Public name As String
    End Structure
    Dim manual(6) As manualStructure
    '
    Dim graph2 As System.Drawing.Graphics
    Dim selectedKnob As PictureBox
    Dim selectedKnobIndex As Integer
    Dim nbKnobsUsed As Integer = 0
    Dim nbStopsUsed As Integer = 0
    Dim manualsNbrOfPipes = 61
    Dim pedalsNbrOfPipes = 32
    Dim neverWarned As Boolean = True ' sert a n'afficher qu'une fois la restriction à 12 jeux


  
    Private Sub Main_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' VERSION ENREGISTREE ?
        check_if_registered()
        ' VERSION PERSO UNIQUEMENT AFFICHERA TAB PAGE 
        If author = False Then TabPage2.Dispose()
        ' AFFICHE REGISTRATION
        TextBoxLogin.Text = licenseUser
        If licenseKey <> "" Then
            TextBoxCode.UseSystemPasswordChar = True
            TextBoxCode.Text = licenseKey
        Else
            TextBoxCode.UseSystemPasswordChar = False
        End If
        ' INITIALISATIONS
        init_All()
    End Sub
    Public Sub init_all()
        Randomize(TimeOfDay.Second)
        nbrOfManuals = 5
        init_knobs()
        init_PictureBoxes()
        init_ManualstopsList()
        init_PedalstopsList()
        init_CouplersList()
        init_tabcontrol()
        init_divisions()
        knobFont = New Font("arial", 8, FontStyle.Regular)
        jambFont = New Font("arial", 11, FontStyle.Regular)
        LabelJambFontName.Text = jambFont.Name
        LabelJambFontName.Font = jambFont
        LabelJambFontSize.Text = jambFont.Size.ToString
        LabelCodfInfo.Text = ""
        RtbCODF.Text = ""
        ' CHEMIN DES CODF ET NOMS DE L'ORGUE
        readCustomOrganPath("customOrgansPath.txt")
        TextBoxCodfPath.Text = customOrgansPath
        TextBoxOrganName.Text = organName
        TextBoxShortName.Text = ShortName
        TextBoxFilename.Text = OrganDefinitionFilename
        '
        CheckBoxSwell_V.Checked = True
        CheckBoxSwell_IV.Checked = True
        CheckBoxSwell_III.Checked = True
        CheckBoxSwell_II.Checked = True
        CheckBoxSwell_I.Checked = True
        ' REVERB
        reverbMode = 1 ' 1= no truncation
        reverbTime = 0 ' ideal 130 à 180 quand mode =2
        NumericReverb.Enabled = False
        ' WIND
        maxFlow = 3 ' soit 3%
        NumericMaxFlow.Value = maxFlow
        ' DIVERS
        labelInf.Text = ""
        LabelManual.Text = ""

    End Sub
    Private Sub init_knobs()
        Dim idx As Integer
        For idx = 0 To 96
            With knob(idx)
                .isRank = False
                .isPedalRank = False
                .isCoupler = False
                .isTremulant = False
                .used = False
                .name = ""
                .folder = ""
                .transpo = 0
                .manual = (Int(idx / 16)) ' numero du clavier, 0 si pedalier
                .isTremulated = False

            End With
        Next
    End Sub
    Private Sub init_PictureBoxes()
        ' INITIALISE LES BOXES
        Dim ctrl As Control
        Dim pBox As PictureBox
        Dim idx As Integer = 0
        Dim pBoxSize As System.Drawing.Size
        pBoxSize.Height = 30
        pBoxSize.Width = 90
        PboxImageOn = My.Resources.blue90x30_on
        PboxImageOff = My.Resources.blue90x30_off


        ' BOUCLE EXPLORANT LES PICTURE BOXES
        For Each ctrl In TabPage1.Controls

            If TypeOf ctrl Is PictureBox Then
                pBox = ctrl
                ' SET THE TAG = N° DU CONTROL
                pBox.Tag = pBox.Name.Substring(10, Len(pBox.Name) - 10)
                ' SET SIZE
                pBox.Size = pBoxSize
                ' SET BORDER
                pBox.BorderStyle = BorderStyle.FixedSingle
                ' SET BACKCOLOR
                pBox.BackColor = Color.Empty
                ' SET BACKGROUND IMAGE
                set_image_Off(pBox)
                ' MANUAL ASSOCIE : VOIR INIT KNOB
            End If
            idx += 1

        Next
    End Sub
    Private Sub init_ManualstopsList()
        ManualStopsList.Items.Clear()
        '
        ManualStopsList.Items.Add("Gambe 16")
        ManualStopsList.Items.Add("Basson 16")
        ManualStopsList.Items.Add("Montre 16")
        ManualStopsList.Items.Add("Bourdon 16")
        ManualStopsList.Items.Add("Quintaton 16")
        ManualStopsList.Items.Add("Trompette 16")
        ManualStopsList.Items.Add("Clarinette 16")
        ManualStopsList.Items.Add("Montre 8")
        ManualStopsList.Items.Add("Flute Douce 8")
        ManualStopsList.Items.Add("Flute Cheminee 8")
        ManualStopsList.Items.Add("Gambe 8")
        ManualStopsList.Items.Add("Quintaton 8")
        ManualStopsList.Items.Add("Cor de Chamois 8")
        ManualStopsList.Items.Add("Principal 8")
        ManualStopsList.Items.Add("Viole de Gambe 8")
        ManualStopsList.Items.Add("Salicional 8")
        ManualStopsList.Items.Add("Bourdon 8")
        ManualStopsList.Items.Add("Trompette 8")
        ManualStopsList.Items.Add("Celeste 8")
        ManualStopsList.Items.Add("Undamaris 8")
        ManualStopsList.Items.Add("Dulciane 8")
        ManualStopsList.Items.Add("Cromorne 8")
        ManualStopsList.Items.Add("Hautbois 8")
        ManualStopsList.Items.Add("Voix Humaine 8")
        ManualStopsList.Items.Add("Clarinette 8")
        ManualStopsList.Items.Add("Regale 8")
        ManualStopsList.Items.Add("Trompette Harm. 8")

        ManualStopsList.Items.Add("Tuba 8")
        ManualStopsList.Items.Add("Prestant 4")
        ManualStopsList.Items.Add("Cor de Chamois 4")
        ManualStopsList.Items.Add("Flute Trav. 4")
        ManualStopsList.Items.Add("Flute Harm. 4")
        ManualStopsList.Items.Add("Flute fuseau 4")
        ManualStopsList.Items.Add("Flute 4")
        ManualStopsList.Items.Add("Principal 4")
        ManualStopsList.Items.Add("Fourniture IV")
        ManualStopsList.Items.Add("Fourniture V")
        ManualStopsList.Items.Add("Clairon 4")
        ManualStopsList.Items.Add("Cornet III")
        ManualStopsList.Items.Add("Doublette 2")
        ManualStopsList.Items.Add("Quinte 2-2/3")
        ManualStopsList.Items.Add("Larigot 1-1/3")
        ManualStopsList.Items.Add("Sesquialtera")
        ManualStopsList.Items.Add("Piccolo 1") ' sifflet
        ManualStopsList.Items.Add("Cymbale III")
        ManualStopsList.Items.Add("Flute Con. 2")
        ManualStopsList.Items.Add("Tierce 1-3/5")
        ManualStopsList.Items.Add("Tierce 3-1/5")
        ManualStopsList.Items.Add("Nasard 2-2/3")
        ManualStopsList.Items.Add("Quinte 5-1/3")
        ManualStopsList.Items.Add("Septade 1-1/7")
        ManualStopsList.Items.Add("Mixture IV")
        ' RECHERCHE DE JEUX AJOUTES
        init_add_Manuals_Stops()

    End Sub
    Private Sub init_add_Manuals_Stops()
        Dim manualsFile As String
        Dim manualsStop As String
        manualsFile = Application.StartupPath & "\manualsNewStops.txt"
        If Not My.Computer.FileSystem.FileExists(manualsFile) Then
            Exit Sub
        End If
        ' ouvrir fichier
        Try
            FileOpen(1, manualsFile, OpenMode.Input)
            ' lire le texte inscit dans le fichier
            While Not EOF(1)
                manualsStop = LineInput(1)
                If manualsStop <> "" Then
                    If manualsStop.Substring(0, 1) <> ";" Then
                        ManualStopsList.Items.Add(manualsStop)
                    End If
                End If
            End While

            FileClose(1)
        Catch
        End Try
    End Sub
    Private Sub init_PedalstopsList()
        PedalStopsList.Items.Clear()
        '
        PedalStopsList.Items.Add("Basse 8")
        PedalStopsList.Items.Add("Bombarde 16")
        PedalStopsList.Items.Add("Bourdon 8")
        PedalStopsList.Items.Add("Clairon 4")
        PedalStopsList.Items.Add("Contrebasse 32")
        PedalStopsList.Items.Add("Prestant 4")
        PedalStopsList.Items.Add("Principal 16")
        PedalStopsList.Items.Add("Soubasse 16")
        PedalStopsList.Items.Add("Basson 16") ' fait avec hautbois
        PedalStopsList.Items.Add("Trompette 8")
        PedalStopsList.Items.Add("Principal 32")
        PedalStopsList.Items.Add("Principal 4")
        PedalStopsList.Items.Add("Fourniture V")
        ' RECHERCHE DE JEUX AJOUTES
        init_add_Pedal_Stops()
    End Sub
    Private Sub init_add_Pedal_Stops()
        Dim pedalFile As String
        Dim pedalStop As String
        pedalFile = Application.StartupPath & "\pedalsNewStops.txt"
        If Not My.Computer.FileSystem.FileExists(pedalFile) Then
            Exit Sub
        End If
        ' ouvrir fichier
        Try
            FileOpen(1, pedalFile, OpenMode.Input)
            ' lire le texte inscit dans le fichier
            While Not EOF(1)
                pedalStop = LineInput(1)
                If pedalStop <> "" Then
                    If pedalStop.Substring(0, 1) <> ";" Then
                        PedalStopsList.Items.Add(pedalStop)
                    End If
                End If
            End While

            FileClose(1)
        Catch
        End Try
    End Sub
    Private Sub init_CouplersList()
        CouplersList.Items.Clear()
        '
        
        CouplersList.Items.Add("* Tremulant *")
        CouplersList.Items.Add("Ped to I 16ft")
        CouplersList.Items.Add("Ped to I 8ft")
        CouplersList.Items.Add("Ped to I 4ft")
        CouplersList.Items.Add("Ped to II 16ft")
        CouplersList.Items.Add("Ped to II 8ft")
        CouplersList.Items.Add("Ped to II 4ft")
        CouplersList.Items.Add("Ped to III 16ft")
        CouplersList.Items.Add("Ped to III 8ft")
        CouplersList.Items.Add("Ped to III 4ft")
        CouplersList.Items.Add("I to Ped 16ft")
        CouplersList.Items.Add("I to Ped 8ft")
        CouplersList.Items.Add("I to Ped 4ft")
        CouplersList.Items.Add("II to Ped 16ft")
        CouplersList.Items.Add("II to Ped 8ft")
        CouplersList.Items.Add("II to Ped 4ft")
        CouplersList.Items.Add("III to Ped 16ft")
        CouplersList.Items.Add("III to Ped 8ft")
        CouplersList.Items.Add("III to Ped 4ft")
        CouplersList.Items.Add("IV to Ped 8ft")
        CouplersList.Items.Add("V to Ped 8ft")
        CouplersList.Items.Add("I to I 16ft")
        CouplersList.Items.Add("I to I Uni.Off")
        CouplersList.Items.Add("I to I 4ft")
        CouplersList.Items.Add("II to I 16ft")
        CouplersList.Items.Add("II to I 8ft")
        CouplersList.Items.Add("II to I 4ft")
        CouplersList.Items.Add("II to II 16ft")
        CouplersList.Items.Add("II to II Uni.Off")
        CouplersList.Items.Add("II to II 4ft")
        CouplersList.Items.Add("III to I 16ft")
        CouplersList.Items.Add("III to I 8ft")
        CouplersList.Items.Add("III to I 4ft")
        CouplersList.Items.Add("III to I Melody")
        CouplersList.Items.Add("III to II 16ft")
        CouplersList.Items.Add("III to II 8ft")
        CouplersList.Items.Add("III to II 4ft")
        CouplersList.Items.Add("III to III 16ft")
        CouplersList.Items.Add("III to III Uni.Off")
        CouplersList.Items.Add("III to III 4ft")
        CouplersList.Items.Add("IV to I 16ft")
        CouplersList.Items.Add("IV to I 8ft")
        CouplersList.Items.Add("IV to I 4ft")
        CouplersList.Items.Add("IV to I Melody")
        CouplersList.Items.Add("IV to II 16ft")
        CouplersList.Items.Add("IV to II 8ft")
        CouplersList.Items.Add("IV to II 4ft")
        CouplersList.Items.Add("IV to III 16ft")
        CouplersList.Items.Add("IV to III 8ft")
        CouplersList.Items.Add("IV to III 4ft")
        CouplersList.Items.Add("IV to IV 16ft")
        CouplersList.Items.Add("IV to IV Uni.Off")
        CouplersList.Items.Add("IV to IV 4ft")
        CouplersList.Items.Add("V to I 16ft")
        CouplersList.Items.Add("V to I 8ft")
        CouplersList.Items.Add("V to I 4ft")
        CouplersList.Items.Add("V to I Melody")
        CouplersList.Items.Add("V to II 16ft")
        CouplersList.Items.Add("V to II 8ft")
        CouplersList.Items.Add("V to II 4ft")
        CouplersList.Items.Add("V to III 16ft")
        CouplersList.Items.Add("V to III 8ft")
        CouplersList.Items.Add("V to III 4ft")
        CouplersList.Items.Add("V to IV 16ft")
        CouplersList.Items.Add("V to IV 8ft")
        CouplersList.Items.Add("V to IV 4ft")
        CouplersList.Items.Add("I to Ped Bass")
        CouplersList.Items.Add("II to Ped Bass")
        CouplersList.Items.Add("III to Ped Bass")
        CouplersList.Items.Add("IV to Ped Bass")
        CouplersList.Items.Add("V to Ped Bass")
    End Sub
    Private Sub init_tabcontrol()
        TabPage1.Text = "STOPS & COUPLERS"
        TabPage2.Text = "INFOS"
    End Sub
    Private Sub init_divisions()
        Dim idx As Integer
        For idx = 0 To 5
            With division(idx)
                .code = idx + 1
                .name = "Keyboard " & 1 + idx.ToString
                .shortName = "Kbd " & 1 + idx.ToString
                .numberOfKeys = manualsNbrOfPipes
                .volume = 0
                If idx = 0 Then .numberOfKeys = pedalsNbrOfPipes ' cas du pedalier
                ' MsgBox("division " & idx.ToString & " keys " & .numberOfKeys.ToString)

                .styleID = 1
                .displayPage = 1
                If idx < 3 Then ' pedal et manuals 1 et 2 a gauche
                    .X = 50
                    .Y = 620 - (60 * idx)
                Else
                    .X = 550
                    .Y = 800 - (60 * idx)
                End If
            End With
        Next
        division(0).name = "Pedalboard"
        division(0).shortName = "Ped"
        division(0).numberOfKeys = 32
        division(0).styleID = 1
    End Sub

    'PICTURE BOXES
    Private Sub PictureBox_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _
    PictureBox1.Click, PictureBox2.Click, PictureBox3.Click, PictureBox4.Click, PictureBox5.Click, PictureBox6.Click, PictureBox7.Click, _
PictureBox8.Click, PictureBox9.Click, PictureBox10.Click, PictureBox11.Click, PictureBox12.Click, PictureBox13.Click, _
PictureBox14.Click, PictureBox15.Click, PictureBox16.Click, PictureBox17.Click, PictureBox18.Click, PictureBox19.Click, _
PictureBox20.Click, PictureBox21.Click, PictureBox22.Click, PictureBox23.Click, PictureBox24.Click, PictureBox25.Click, _
PictureBox26.Click, PictureBox27.Click, PictureBox28.Click, PictureBox29.Click, PictureBox30.Click, PictureBox31.Click, _
PictureBox32.Click, PictureBox33.Click, PictureBox34.Click, PictureBox35.Click, PictureBox36.Click, PictureBox37.Click, _
PictureBox38.Click, PictureBox39.Click, PictureBox40.Click, PictureBox41.Click, PictureBox42.Click, PictureBox43.Click, _
PictureBox44.Click, PictureBox45.Click, PictureBox46.Click, PictureBox47.Click, PictureBox48.Click, PictureBox49.Click, _
PictureBox50.Click, PictureBox51.Click, PictureBox52.Click, PictureBox53.Click, PictureBox54.Click, PictureBox55.Click, _
PictureBox56.Click, PictureBox57.Click, PictureBox58.Click, PictureBox59.Click, PictureBox60.Click, PictureBox61.Click, _
PictureBox62.Click, PictureBox63.Click, PictureBox64.Click, PictureBox65.Click, PictureBox66.Click, PictureBox67.Click, _
PictureBox68.Click, PictureBox69.Click, PictureBox70.Click, PictureBox71.Click, PictureBox72.Click, PictureBox73.Click, _
PictureBox74.Click, PictureBox75.Click, PictureBox76.Click, PictureBox77.Click, PictureBox78.Click, PictureBox79.Click, _
PictureBox80.Click, PictureBox81.Click, PictureBox82.Click, PictureBox83.Click, PictureBox84.Click, PictureBox85.Click, _
PictureBox86.Click, PictureBox87.Click, PictureBox88.Click, PictureBox89.Click, PictureBox90.Click, PictureBox91.Click, _
PictureBox92.Click, PictureBox93.Click, PictureBox94.Click, PictureBox95.Click, PictureBox96.Click
        ' ACTION A EFFECTUER QUAND ON CLIQUE SUR UNE DES BOX

        selectedKnob = sender
        selectedKnobIndex = Val(sender.tag)
        labelInf.Text = Val(sender.Tag)
        ' CHANGER L'IMAGE
        set_image_On(sender)
    End Sub
    Private Sub PictureBox_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles _
PictureBox1.Paint, PictureBox2.Paint, PictureBox3.Paint, PictureBox4.Paint, PictureBox5.Paint, PictureBox6.Paint, PictureBox7.Paint, _
PictureBox8.Paint, PictureBox9.Paint, PictureBox10.Paint, PictureBox11.Paint, PictureBox12.Paint, PictureBox13.Paint, _
PictureBox14.Paint, PictureBox15.Paint, PictureBox16.Paint, PictureBox17.Paint, PictureBox18.Paint, PictureBox19.Paint, _
PictureBox20.Paint, PictureBox21.Paint, PictureBox22.Paint, PictureBox23.Paint, PictureBox24.Paint, PictureBox25.Paint, _
PictureBox26.Paint, PictureBox27.Paint, PictureBox28.Paint, PictureBox29.Paint, PictureBox30.Paint, PictureBox31.Paint, _
PictureBox32.Paint, PictureBox33.Paint, PictureBox34.Paint, PictureBox35.Paint, PictureBox36.Paint, PictureBox37.Paint, _
PictureBox38.Paint, PictureBox39.Paint, PictureBox40.Paint, PictureBox41.Paint, PictureBox42.Paint, PictureBox43.Paint, _
PictureBox44.Paint, PictureBox45.Paint, PictureBox46.Paint, PictureBox47.Paint, PictureBox48.Paint, PictureBox49.Paint, _
PictureBox50.Paint, PictureBox51.Paint, PictureBox52.Paint, PictureBox53.Paint, PictureBox54.Paint, PictureBox55.Paint, _
PictureBox56.Paint, PictureBox57.Paint, PictureBox58.Paint, PictureBox59.Paint, PictureBox60.Paint, PictureBox61.Paint, _
PictureBox62.Paint, PictureBox63.Paint, PictureBox64.Paint, PictureBox65.Paint, PictureBox66.Paint, PictureBox67.Paint, _
PictureBox68.Paint, PictureBox69.Paint, PictureBox70.Paint, PictureBox71.Paint, PictureBox72.Paint, PictureBox73.Paint, _
PictureBox74.Paint, PictureBox75.Paint, PictureBox76.Paint, PictureBox77.Paint, PictureBox78.Paint, PictureBox79.Paint, _
PictureBox80.Paint, PictureBox81.Paint, PictureBox82.Paint, PictureBox83.Paint, PictureBox84.Paint, PictureBox85.Paint, _
PictureBox86.Paint, PictureBox87.Paint, PictureBox88.Paint, PictureBox89.Paint, PictureBox90.Paint, PictureBox91.Paint, _
PictureBox92.Paint, PictureBox93.Paint, PictureBox94.Paint, PictureBox95.Paint, PictureBox96.Paint

        Dim pBox As PictureBox = sender
        Dim idx As Integer = Val(pBox.Tag)
        Dim text As String
        labelInf.Text = pBox.Tag
        If knob(idx).used = True Then
            text = knob(idx).name
            e.Graphics.DrawString(text, knobFont, Brushes.Black, New PointF(5, 8))
        End If
    End Sub

    ' GESTION IMAGES ET TEXTES DES PICTUREBOXES
    Private Sub set_image_On(ByVal PBox As PictureBox)
        ' AFFICHE LA BOX EN POSITION ON
        PBox.BackgroundImage = PboxImageOn
    End Sub
    Private Sub set_image_Off(ByVal PBox As PictureBox)
        ' AFFICHE LA BOX EN POSITION OFF
        Try
            PBox.BackgroundImage = PboxImageOff
        Catch
            MsgBox("selectedKnob a knob first")
        End Try
    End Sub

    ' TAB PAGE 1
    Private Sub TabPage1_Refresh()
        ' REFRESH L'AFFICHAGE DES PBOXES
        ' NECESSAIRE SI ON CHANGE DE FONTE OU SI ON CHANGE D'ONGLET
        TabPage1.Refresh()
    End Sub
    Private Sub ButtonFont_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonFont.Click
        ' CHANGE LE STYLE ET LA TAILLE DES CARACTERES EN PAGE CONSOLE
        Dim dlg As New FontDialog
        If dlg.ShowDialog = Windows.Forms.DialogResult.OK Then
            knobFont = dlg.Font
        End If
        ' UPDATE INDISPENSABLE
        TabPage1_Refresh()

    End Sub

    ' LISTES
    Private Sub manualStopsList_Changed(ByVal sender As Object, ByVal e As System.EventArgs) Handles ManualStopsList.SelectedIndexChanged
        manualStopsList_Action()
    End Sub
    Private Sub manualStopsList_Action()
        ' RECUPERE DANS LA LISTE LE NOM D'UN REGISTRE
        Dim selectedText = ManualStopsList.SelectedItem
        Dim pBox = selectedKnob

        ' IL FAUT D'ABORD AVOIR CHOISI UNE BOX
        If pBox Is Nothing Then Exit Sub
        ' VOIR SI VERSION NON ENREGISTREE
        If registered = False And nbStopsUsed > 11 And selectedText <> "* ERASE *" Then
            If neverWarned = True Then MsgBox("The limit of unregistered version is 12 stops") : neverWarned = False
            Exit Sub
        End If

        ' ECRIT LE TEXTE DANS LA PICTURE BOX
        ' ECRIT INFOS DANS TABLEAU KNOB()
        With knob(selectedKnobIndex)
            .used = True
            .name = selectedText
            .isRank = True
            .isPedalRank = False
            .isCoupler = False
            .isTremulant = False
            If CheckBoxNameInCaps.Checked = True Then .name = .name.ToUpper
            .folder = getFileName(.name)
            .subFolder = "Manuals"
            .manual = getManualNumber(selectedKnobIndex)
            .enclosureCode = getEnclosureCode(.manual)
            LabelManual.Text = .manual.ToString
            .stopcode = 2000 + (100 * .manual) + selectedKnobIndex
            .loc1 = pBox.Location
            Select Case selectedKnobIndex
                Case Is < 17 : .numberOfPipes = pedalsNbrOfPipes
                Case Else : .numberOfPipes = manualsNbrOfPipes
            End Select
        End With
        nbKnobsUsed += 1 : LabelKnobsUsed.Text = nbKnobsUsed.ToString
        nbStopsUsed += 1 : LabelStopsUsed.Text = nbStopsUsed.ToString
        pBox.Refresh() ' OBLIGATOIRE : force l'execution de l'event PAINT


    End Sub
    Private Sub PedalStopsList_Changed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PedalStopsList.SelectedIndexChanged
        ' RECUPERE DANS LA LISTE PEDALS LE NOM D'UN REGISTRE
        Dim selectedText = PedalStopsList.SelectedItem
        Dim pbox = selectedKnob

        ' IL FAUT D'ABORD AVOIR CHOISI UNE BOX
        If pbox Is Nothing Then Exit Sub
        ' VOIR SI VERSION NON ENREGISTREE
        If registered = False And nbStopsUsed > 11 And selectedText <> "* ERASE *" Then
            MsgBox("Limit of unregistered version is 12 stops")
            Exit Sub
        End If

        ' ECRIT LE TEXTE DANS LA PICTURE BOX
        ' ECRIT INFOS DANS TABLEAU KNOB()
        With knob(selectedKnobIndex)
            .used = True
            .name = selectedText
            .isRank = True
            .isPedalRank = True
            .isCoupler = False
            .isTremulant = False
            If CheckBoxNameInCaps.Checked = True Then .name = .name.ToUpper
            .folder = getFileName(.name)
            .subFolder = "Pedals"
            .manual = getManualNumber(selectedKnobIndex)
            .enclosureCode = getEnclosureCode(.manual)
            LabelManual.Text = .manual.ToString
            .stopcode = 2000 + (100 * .manual) + selectedKnobIndex
            .loc1 = pbox.Location
            Select Case selectedKnobIndex
                Case Is < 17 : .numberOfPipes = pedalsNbrOfPipes
                Case Else
                    .numberOfPipes = manualsNbrOfPipes
                    MsgBox("Please, notice this rank should be for pedals only")
            End Select
        End With
        nbKnobsUsed += 1 : LabelKnobsUsed.Text = nbKnobsUsed.ToString
        nbStopsUsed += 1 : LabelStopsUsed.Text = nbStopsUsed.ToString
        pbox.Refresh() ' OBLIGATOIRE : force l'execution de l'event PAINT

    End Sub
    Private Sub CouplersList_Changed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CouplersList.SelectedIndexChanged
        ' RECUPERE DANS LA LISTE COUPLERS LE NOM D'UN COUPLER
        Dim selectedText = CouplersList.SelectedItem
        Dim pbox = selectedKnob

        ' IL FAUT D'ABORD AVOIR CHOISI UNE BOX
        If pbox Is Nothing Then Exit Sub

        ' ECRIT LE TEXTE DANS LA PICTURE BOX
        ' ECRIT INFOS DANS TABLEAU KNOB()
        With knob(selectedKnobIndex)
            .used = True
            .name = selectedText
            .isRank = False
            .isPedalRank = False
            If selectedText <> "* Tremulant *" Then
                .isCoupler = True
                .isTremulant = False
            Else
                .isCoupler = False
                .isTremulant = True
            End If
            .loc1 = pbox.Location
            If CheckBoxNameInCaps.Checked = True Then .name = .name.ToUpper
            .manual = getManualNumber(selectedKnobIndex)
            LabelManual.Text = .manual.ToString
        End With

        nbKnobsUsed += 1 : LabelKnobsUsed.Text = nbKnobsUsed.ToString
        pbox.Refresh() ' OBLIGATOIRE : force l'execution de l'event PAINT


    End Sub

    ' TAB PAGE 2 (INFOS)
    Private Sub ButtonInfos_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonInfos.Click
        ' AFFICHE LES INFOS SUR LES KNOBS UTILISES
        Display_Infos()
    End Sub
    Private Sub Display_Infos()
        ' AFFICHE DANS UNE RICHETEXTBOX LES INFOS SUR LES KNOBS UTILISES
        Dim idx As Integer
        Dim txt As String = ""
        ' CHECK TREMULATED STOPS
        search_Tremulated_Stops()
        ' EFFACE
        RTBox.Text = ""
        ' BOUCLE
        For idx = 0 To 96
            With knob(idx)
                If .used = True Then
                    txt += vbCrLf & idx.ToString & " = "
                    If .isRank = True Then
                        txt += "RANK " & .name.ToUpper & "   " & .subFolder & "/" & .folder
                        txt += vbCrLf & "StopCode = " & .stopcode
                        txt += vbCrLf & CStr(IIf(.isTremulated = True, "with tremulant", "no tremulant"))
                    End If
                    If .isCoupler = True Then
                        txt += "COUPLER " & .name.ToUpper & "   Coupler code : " & .couplerCode
                    End If
                    If .isTremulant = True Then
                        txt += "TREMULANT " & "   Tremulant code : " & .tremulantCode
                    End If
                    txt += vbCrLf & "Manual = " & .manual

                    txt += vbCrLf & "Location X1, Y1 = " & .loc1.X & ", " & .loc1.Y
                    txt += vbCrLf & "Location X2, Y2 = " & .loc2.X & ", " & .loc2.Y
                    txt += vbCrLf
                End If
            End With

        Next
        RTBox.Text = txt
    End Sub
    Private Sub KnobStyle_Changed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _
    RadioYelllow.CheckedChanged, RadioWood.CheckedChanged, RadioBlue.CheckedChanged
        ' POUR CHANGER DE TYPE DE KNOB
        changeKnobStyle()
    End Sub
    Public Sub changeKnobStyle()
        ' CHANGER LE TYPE DE KNOB
        If RadioYelllow.Checked = True Then
            ' PARAMETRE POUR L'ODF
            buttonOn = "yellow90x30_on.bmp"
            buttonOff = "yellow90x30_off.bmp"
            ' PARAMETRE POUR L'AFFICHAGE DES BOXES
            PboxImageOn = My.Resources.yellow90x30_on
            PboxImageOff = My.Resources.yellow90x30_off
        End If
        If RadioBlue.Checked = True Then
            ' PARAMETRE POUR L'ODF
            buttonOn = "blue90x30_on.bmp"
            buttonOff = "blue90x30_off.bmp"
            ' PARAMETRE POUR L'AFFICHAGE DES BOXES
            PboxImageOn = My.Resources.blue90x30_on
            PboxImageOff = My.Resources.blue90x30_off
        End If
        If RadioWood.Checked = True Then
            buttonOn = "button90xx30LightWood.bmp"
            buttonOff = "button90xx30Wood.bmp"
            PboxImageOn = My.Resources.button90xx30lightWood
            PboxImageOff = My.Resources.button90xx30wood
        End If
        'TabPage1_Refresh()
        Dim ctrl As Control
        Dim idx As Integer = 0
        For Each ctrl In TabPage1.Controls
            If TypeOf ctrl Is PictureBox Then
                ' THE TAG = N° DU CONTROL
                'ctrl.Tag = ctrl.Name.Substring(10, Len(ctrl.Name) - 10)
                idx = ctrl.Tag
                If knob(idx).used = True Then
                    ctrl.BackgroundImage = PboxImageOn
                Else
                    ctrl.BackgroundImage = PboxImageOff
                End If
                'idx += 1
            End If

        Next
        'TabPage1.Refresh()
    End Sub

    ' TAB PAGE 3 (SETUP)
    Private Sub NumericNbrOfManuals_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericNbrOfManuals.ValueChanged
        ' CHOIX DU NOMBRE DE CLAVIERS
        nbrOfManuals = NumericNbrOfManuals.Value
        ' VALIDATION DES SWELL BOXES
        validate_swellBox()
        ' GESTION DES BOXES
        gestion_des_boxes()

    End Sub
    Private Sub NumNbrKeyManuals_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumNbrKeyManuals.ValueChanged
        manualsNbrOfPipes = NumNbrKeyManuals.Value
        division(1).numberOfKeys = manualsNbrOfPipes
        division(2).numberOfKeys = manualsNbrOfPipes
        division(3).numberOfKeys = manualsNbrOfPipes
        division(4).numberOfKeys = manualsNbrOfPipes
        division(5).numberOfKeys = manualsNbrOfPipes
    End Sub
    Private Sub NumNbrKeyPedals_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumNbrKeyPedals.ValueChanged
        pedalsNbrOfPipes = NumNbrKeyPedals.Value
        division(0).numberOfKeys = pedalsNbrOfPipes
    End Sub
    Private Sub validate_swellBox()
        If nbrOfManuals < 5 Then CheckBoxSwell_V.Checked = False
        If nbrOfManuals < 4 Then CheckBoxSwell_IV.Checked = False
        If nbrOfManuals < 3 Then CheckBoxSwell_III.Checked = False
        If nbrOfManuals < 2 Then CheckBoxSwell_II.Checked = False
        CheckBoxSwell_V.Enabled = IIf(nbrOfManuals = 5, True, False)
        CheckBoxSwell_IV.Enabled = IIf(nbrOfManuals >= 4, True, False)
        CheckBoxSwell_III.Enabled = IIf(nbrOfManuals >= 3, True, False)
        CheckBoxSwell_II.Enabled = IIf(nbrOfManuals >= 2, True, False)



    End Sub
    Private Sub ButtonJambFont_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonJambFont.Click
        ' CHANGE LE STYLE ET LA TAILLE DES CARACTERES EN PAGE CONSOLE
        Dim dlg As New FontDialog
        If dlg.ShowDialog = Windows.Forms.DialogResult.OK Then
            jambFont = dlg.Font
        End If
        LabelJambFontName.Text = jambFont.Name
        LabelJambFontName.Font = jambFont
        LabelJambFontSize.Text = jambFont.Size.ToString
    End Sub
    Private Sub CheckBoxReverb_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxReverb.CheckedChanged
        If CheckBoxReverb.Checked Then
            reverbMode = 2 ' reverb sera tronquée
            NumericReverb.Enabled = True
            reverbTime = NumericReverb.Value
        Else
            reverbMode = 1 ' reverb non tronquée
            NumericReverb.Enabled = False
            reverbTime = 0
        End If
    End Sub
    Private Sub NumericReverb_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericReverb.ValueChanged
        If CheckBoxReverb.Checked Then
            reverbTime = NumericReverb.Value
        End If
    End Sub
    Private Sub NumericMaxFlow_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericMaxFlow.ValueChanged
        maxFlow = NumericMaxFlow.Value
    End Sub
    Private Sub numTremulantFrequency_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numTremulantFrequency.ValueChanged
        tremulantFrequency = numTremulantFrequency.Value
    End Sub
    ' VOLUMES
    Private Sub VolumePed_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numericVolumePed.ValueChanged
        division(0).volume = numericVolumePed.Value
    End Sub
    Private Sub VolumeM1_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericVolumeM1.ValueChanged
        division(1).volume = NumericVolumeM1.Value
    End Sub
    Private Sub VolumeM2_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericVolumeM2.ValueChanged
        division(2).volume = NumericVolumeM2.Value
    End Sub
    Private Sub VolumeM3_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericVolumeM3.ValueChanged
        division(3).volume = NumericVolumeM3.Value
    End Sub
    Private Sub VolumeM4_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericVolumeM4.ValueChanged
        division(4).volume = NumericVolumeM4.Value
    End Sub
    Private Sub VolumeM5_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericVolumeM5.ValueChanged
        division(5).volume = NumericVolumeM5.Value
    End Sub

    '
    Private Sub Button_Save_CODF_Path(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSaveCodfPath.Click
        customOrgansPath = TextBoxCodfPath.Text
        saveCodfPath("customOrgansPath.txt")
    End Sub
    Private Sub NumericUniqueOrganID_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUniqueOrganID.ValueChanged
        UniqueOrganID = NumericUniqueOrganID.Value
        TextBoxFilename.Text = "Basilica (" & UniqueOrganID.ToString & ")"
    End Sub
    Private Sub TextBoxOrganName_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxOrganName.TextChanged
        organName = TextBoxOrganName.Text
    End Sub
    Private Sub TextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxShortName.TextChanged
        ShortName = TextBoxShortName.Text
    End Sub
    Private Sub TextBoxFilename_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxFilename.TextChanged
        OrganDefinitionFilename = TextBoxFilename.Text
    End Sub
    '
    Private Sub ButtonRegister_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonRegister.Click

        ' ENREGISTRE LE LOGIN ET LE PASSWORD
        Dim sw As New StreamWriter(licenseFile)
        Try
            sw.WriteLine(TextBoxLogin.Text.ToUpper)
            sw.WriteLine(Val(TextBoxCode.Text))
            sw.Close()
        Catch
            MsgBox("Basilica cannot create the license file in its directory")
        End Try
        MsgBox("For your validation to be effective, please leave the program and restart it.")
    End Sub

    ' TAB PAGE 4 (CODF)
    Private Sub ButtonCreateCODF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonCreateCODF.Click
        ' ASSEMBLE LES DIFFERENTES SECTIONS DU CODF
        Dim idx As Integer

        LabelCodfInfo.Text = "Please Wait" : LabelCodfInfo.Refresh()
        ' D'ABORD CALCULER LES POSITIONS DES KNOBS DANS LES JAMBES
        compute_location_in_jambs()
        ' PUIS CHERCHER LES JEUX TREMULEES
        search_Tremulated_Stops()

        ' ASSEMBLE ENTETE
        make_Header()
        make_General()
        make_required()
        make_CustomDisplayPage()
        '
        ' DIVISIONS
        RtbCODF.Text += "<ObjectList ObjectType = " & Chr(34) & "division" & Chr(34) & ">" & vbCrLf
        For idx = 0 To nbrOfManuals
            make_Division(idx)
        Next
        RtbCODF.Text += "</ObjectList>" & vbCrLf

        ' CUSTOM DISPLAY MANUALS
        make_Manual()

        ' CUSTOM DISPLAY KNOBS
        RtbCODF.Text += "<ObjectList ObjectType=" & Chr(34) & "customdisplaycontrolstyle" & Chr(34) & ">" & vbCrLf
        make_CustomDisplayObjects()
        make_customExpPedal()
        RtbCODF.Text += "</ObjectList>" & vbCrLf

        ' COUPLERS
        RtbCODF.Text += "<ObjectList ObjectType=" & Chr(34) & "coupler" & Chr(34) & ">" & vbCrLf
        prepare_couplers()
        RtbCODF.Text += "</ObjectList>" & vbCrLf

        ' TREMULANTS
        RtbCODF.Text += "<ObjectList ObjectType=" & Chr(34) & "tremulant" & Chr(34) & ">" & vbCrLf
        prepare_tremulants()
        RtbCODF.Text += "</ObjectList>" & vbCrLf

        ' ENCLOSURES
        RtbCODF.Text += "<ObjectList ObjectType=" & Chr(34) & "enclosure" & Chr(34) & ">" & vbCrLf
        prepare_enclosures()
        RtbCODF.Text += "</ObjectList>" & vbCrLf

        '
        ' RANKS
        RtbCODF.Text += "<ObjectList ObjectType=" & Chr(34) & "rank" & Chr(34) & ">" & vbCrLf
        prepare_ranks()
        RtbCODF.Text += "</ObjectList>" & vbCrLf
        '
        ' STOPPRANKS
        RtbCODF.Text += "<ObjectList ObjectType=" & Chr(34) & "stoprank" & Chr(34) & ">" & vbCrLf
        prepare_stopRanks()
        RtbCODF.Text += "</ObjectList>" & vbCrLf
        '
        ' STOPS
        RtbCODF.Text += "<ObjectList ObjectType=" & Chr(34) & "stop" & Chr(34) & ">" & vbCrLf
        prepare_stops()
        RtbCODF.Text += "</ObjectList>" & vbCrLf
        '
        ' LABELS
        RtbCODF.Text += "<ObjectList ObjectType=" & Chr(34) & "customdisplaylabel" & Chr(34) & ">" & vbCrLf
        prepare_labels()
        ' AJOUTER LES BANDES HORIZONTALES QUI SONT AUSSI DES LABELS
        make_bandeH()
        RtbCODF.Text += "</ObjectList>" & vbCrLf

        'ENDING
        RtbCODF.Text += "</Hauptwerk>" & vbCrLf
        LabelCodfInfo.Text = "CODF Completed" : LabelCodfInfo.Refresh()

    End Sub
    Private Sub ButtonSaveCodf_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSaveCodf.Click
        Dim file As String
        file = customOrgansPath & "/"
        file += OrganDefinitionFilename
        file += ".CustomOrgan_Hauptwerk_xml"
        Try
            RtbCODF.SaveFile(file, RichTextBoxStreamType.PlainText)
            LabelCodfInfo.Text = "CODF Saved"
        Catch
            LabelCodfInfo.Text = "Saving CODF failed"
        End Try
    End Sub

    ' GESTION DES BOXES
    Public Sub gestion_des_boxes()
        ' GESTION DES BOXES DANS TABPAGE1
        ' PLACE LES BOXES SELON LE NOMBRE DE CLAVIERS
        Dim ctrl As Control
        Dim pBox As PictureBox
        Dim idx As Integer = 0
        Dim Loc As System.Drawing.Point
        Dim siz As System.Drawing.Size
        Const h1 = 34
        Const h2 = 42
        Dim st As Integer = 424 ' start 

        ' POSITION DE DEPART DES BOX
        Select Case nbrOfManuals
            Case 5 : st = 420
            Case 4 : st = 420 - h1 - h2
            Case 3 : st = 420 - h2 - h2
            Case 2 : st = 420 - h2 - h2 - h2
            Case 1 : st = 420 - h1 - h1 - h1 - h1 + 2
        End Select

        ' POSITION ET VISIBILITE DES LABELS
        Select Case nbrOfManuals
            Case 5
                LabelManual5.Visible = True
                LabelManual5.Location = New Point(10, 10)
                LabelManual4.Visible = True
                LabelManual4.Location = New Point(10, 86)
                LabelManual3.Visible = True
                LabelManual3.Location = New Point(10, 160)
                LabelManual2.Visible = True
                LabelManual2.Location = New Point(10, 238)
                LabelManual1.Location = New Point(10, 314)
                LabelPedals.Location = New Point(10, 390)
            Case 4
                LabelManual5.Visible = False
                LabelManual4.Visible = True
                LabelManual4.Location = New Point(10, 10)
                LabelManual3.Visible = True
                LabelManual3.Location = New Point(10, 86)
                LabelManual2.Visible = True
                LabelManual2.Location = New Point(10, 160)
                LabelManual1.Location = New Point(10, 238)
                LabelPedals.Location = New Point(10, 314)
            Case 3
                LabelManual5.Visible = False
                LabelManual4.Visible = False
                LabelManual3.Visible = True
                LabelManual3.Location = New Point(10, 10)
                LabelManual2.Visible = True
                LabelManual2.Location = New Point(10, 86)
                LabelManual1.Location = New Point(10, 196)
                LabelPedals.Location = New Point(10, 306)
            Case 2
                LabelManual5.Visible = False
                LabelManual4.Visible = False
                LabelManual3.Visible = False
                LabelManual2.Visible = True
                LabelManual2.Location = New Point(10, 10)
                LabelManual1.Visible = True
                LabelManual1.Location = New Point(10, 120)
                LabelPedals.Location = New Point(10, 264)
            Case 1
                LabelManual5.Visible = False
                LabelManual4.Visible = False
                LabelManual3.Visible = False
                LabelManual2.Visible = False
                LabelManual1.Location = New Point(10, 10)
                LabelPedals.Location = New Point(10, 256)
        End Select

        ' POSITION ET TAILLE DES LISTES
        Loc = LabelListStop.Location : Loc.Y = st + 50
        LabelListStop.Location = Loc
        Loc = LabelListPedal.Location : Loc.Y = st + 50
        LabelListPedal.Location = Loc
        Loc = LabelListCoupler.Location : Loc.Y = st + 50
        LabelListCoupler.Location = Loc
        '
        Loc = ManualStopsList.Location : Loc.Y = st + 70
        ManualStopsList.Location = Loc
        Loc = PedalStopsList.Location : Loc.Y = st + 70
        PedalStopsList.Location = Loc
        Loc = CouplersList.Location : Loc.Y = st + 70
        CouplersList.Location = Loc
        '
        siz = ManualStopsList.Size : siz.Height = 560 - st
        ManualStopsList.Size = siz
        siz = PedalStopsList.Size : siz.Height = 560 - st
        PedalStopsList.Size = siz
        siz = CouplersList.Size : siz.Height = 560 - st
        CouplersList.Size = siz


        ' BOUCLE EXPLORANT LES PICTURE BOXES
        ' POSITIONNE LES BOX ET LEUR AFFECTE UN CLAVIER
        For Each ctrl In TabPage1.Controls

            If TypeOf ctrl Is PictureBox Then
                pBox = ctrl
                ' THE TAG = N° DU CONTROL
                pBox.Tag = pBox.Name.Substring(10, Len(pBox.Name) - 10)
                idx = Val(pBox.Tag)
                Loc = pBox.Location
                Select Case idx
                    Case 1 To 8 ' PEDAL
                        Loc.Y = st : pBox.Location = Loc
                    Case 9 To 16 ' PEDAL
                        Loc.Y = st - h1 : pBox.Location = Loc
                    Case 17 To 24 'MANUAL 1
                        Loc.Y = st - h1 - h2 : pBox.Location = Loc
                    Case 25 To 32 'MANUAL 1
                        Loc.Y = st - h1 - h2 - h1 : pBox.Location = Loc
                    Case 33 To 40
                        ' SI UN A 3 CLAVIERS
                        If nbrOfManuals <= 3 Then Loc.Y = st - h1 - h2 - h1 - h1 : pBox.Location = Loc
                        ' SI DEUX CLAVIERS
                        'If nbrOfManuals = 2 Then Loc.Y = st - h1 - h2 - h1 - h1 : pBox.Location = Loc
                        ' SI TROIS CLAVIERS
                        'If nbrOfManuals = 3 Then Loc.Y = st - h1 - h2 - h1 - h1 : pBox.Location = Loc
                        ' SI 4 OU 5 CLAVIERS
                        If nbrOfManuals >= 4 Then Loc.Y = st - h1 - h2 - h1 - h2 : pBox.Location = Loc
                        ' SI 5 CLAVIERS
                        ' If nbrOfManuals = 5 Then Loc.Y = st - h1 - h2 - h1 - h2 : pBox.Location = Loc
                    Case 41 To 48
                        ' SI UN OU 2 CLAVIERS
                        If nbrOfManuals <= 2 Then Loc.Y = st - h1 - h2 - h1 - h1 - h1 : pBox.Location = Loc
                        ' SI DEUX CLAVIERS
                        ' If nbrOfManuals = 2 Then Loc.Y = st - h1 - h2 - h1 - h1 - h1 : pBox.Location = Loc
                        ' SI TROIS CLAVIERS
                        If nbrOfManuals = 3 Then Loc.Y = st - h1 - h2 - h1 - h1 - h2 : pBox.Location = Loc
                        ' SI 4 OU 5 CLAVIERS
                        If nbrOfManuals >= 4 Then Loc.Y = st - h1 - h2 - h1 - h2 - h1 : pBox.Location = Loc
                        ' SI 5 CLAVIERS
                        ' If nbrOfManuals = 5 Then Loc.Y = st - h1 - h2 - h1 - h2 - h1 : pBox.Location = Loc
                    Case 49 To 56
                        ' SI UN SEUL CLAVIER
                        If nbrOfManuals = 1 Then Loc.Y = st - h1 - h2 - h1 - h1 - h1 - h1 : pBox.Location = Loc
                        ' SI DEUX CLAVIERS
                        If nbrOfManuals = 2 Then Loc.Y = st - h1 - h2 - h1 - h1 - h1 - h2 : pBox.Location = Loc
                        ' SI TROIS CLAVIERS
                        If nbrOfManuals = 3 Then Loc.Y = st - h1 - h2 - h1 - h1 - h2 - h1 : pBox.Location = Loc
                        ' SI 4 OU 5 CLAVIERS
                        If nbrOfManuals >= 4 Then Loc.Y = st - h1 - h2 - h1 - h2 - h1 - h2 : pBox.Location = Loc
                        ' SI 5 CLAVIERS
                        ' If nbrOfManuals = 5 Then Loc.Y = st - h1 - h2 - h1 - h2 - h1 - h2 : pBox.Location = Loc
                    Case 57 To 64
                        ' SI UN SEUL CLAVIER
                        If nbrOfManuals = 1 Then Loc.Y = st - h1 - h2 - h1 - h1 - h1 - h1 - h1 : pBox.Location = Loc
                        knob(idx).manual = 1
                        ' SI DEUX CLAVIERS
                        If nbrOfManuals = 2 Then Loc.Y = st - h1 - h2 - h1 - h1 - h1 - h2 - h1 : pBox.Location = Loc
                        ' SI TROIS CLAVIERS
                        If nbrOfManuals = 3 Then Loc.Y = st - h1 - h2 - h1 - h1 - h2 - h1 - h1 : pBox.Location = Loc
                        ' SI 4 OU 5 CLAVIERS
                        If nbrOfManuals >= 4 Then Loc.Y = st - h1 - h2 - h1 - h2 - h1 - h2 - h1 : pBox.Location = Loc
                        ' SI 5 CLAVIERS
                        ' If nbrOfManuals = 5 Then Loc.Y = st - h1 - h2 - h1 - h2 - h1 - h2 - h1 : pBox.Location = Loc
                    Case 65 To 72
                        ' SI UN SEUL CLAVIER
                        If nbrOfManuals = 1 Then Loc.Y = st - h1 - h2 - h1 - h1 - h1 - h1 - h1 - h1 : pBox.Location = Loc
                        ' SI DEUX CLAVIERS
                        If nbrOfManuals = 2 Then Loc.Y = st - h1 - h2 - h1 - h1 - h1 - h2 - h1 - h1 : pBox.Location = Loc
                        ' SI TROIS CLAVIERS
                        If nbrOfManuals = 3 Then Loc.Y = st - h1 - h2 - h1 - h1 - h2 - h1 - h1 - h2 : pBox.Location = Loc
                        ' SI 4 OU 5 CLAVIERS
                        If nbrOfManuals >= 4 Then Loc.Y = st - h1 - h2 - h1 - h2 - h1 - h2 - h1 - h2 : pBox.Location = Loc
                        ' SI 5 CLAVIERS
                        ' If nbrOfManuals = 5 Then Loc.Y = st - h1 - h2 - h1 - h2 - h1 - h2 - h1 - h2 : pBox.Location = Loc
                    Case 73 To 80
                        ' SI UN SEUL CLAVIER
                        If nbrOfManuals = 1 Then Loc.Y = st - h1 - h2 - h1 - h1 - h1 - h1 - h1 - h1 - h1 : pBox.Location = Loc
                        ' SI DEUX CLAVIERS
                        If nbrOfManuals = 2 Then Loc.Y = st - h1 - h2 - h1 - h1 - h1 - h2 - h1 - h1 - h1 : pBox.Location = Loc
                        ' SI TROIS CLAVIERS
                        If nbrOfManuals = 3 Then Loc.Y = st - h1 - h2 - h1 - h1 - h2 - h1 - h1 - h2 - h1 : pBox.Location = Loc
                        ' SI 4 CLAVIERS
                        If nbrOfManuals = 4 Then Loc.Y = st - h1 - h2 - h1 - h2 - h1 - h2 - h1 - h1 - h2 : pBox.Location = Loc
                        ' SI 5 CLAVIERS
                        If nbrOfManuals = 5 Then Loc.Y = st - h1 - h2 - h1 - h2 - h1 - h2 - h1 - h2 - h1 : pBox.Location = Loc
                    Case 81 To 88
                        Loc.Y = st - h1 - h2 - h1 - h2 - h1 - h2 - h1 - h2 - h1 - h2 : pBox.Location = Loc
                    Case 89 To 96
                        Loc.Y = st - h1 - h2 - h1 - h2 - h1 - h2 - h1 - h2 - h1 - h2 - h1 : pBox.Location = Loc
                End Select
            End If

        Next
    End Sub
    Private Sub ButtonClearAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonClearPBox.Click
        clear_pBoxes()
    End Sub

    ' OUTILS PERSO
    Private Sub Create_handle(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonTool1.Click
        ' CREE LA LISTE DES 96 HANDLES
        Dim x
        RTBox.Text = ""
        For x = 0 To 95
            RTBox.Text += "picturebox" & (x + 1).ToString & ".paint,"
            If x Mod 6 = 0 Then RTBox.Text += " _" & vbCrLf
        Next
    End Sub
    Private Sub XML_to_VB_convert(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonConvertXmlToVB.Click
        ' TRANSFORME XML en VB EN AJOUTANT rtbCODF +="
        ' ON RECUPERE LE TEXTE AVEC CTRL-C
        '
        ' TEXTE A CONVERTIR

        '
        Dim lines() As String = RTBox.Lines

        ' BOUCLE
        Dim idx As Integer
        For idx = LBound(lines) To UBound(lines)
            lines(idx) = "txt += " & Chr(34) & lines(idx) & Chr(34) & " & VBCRLF"
            RTBox.Lines = lines
        Next
    End Sub

    ' FONCTIONS
    Function getFileName(ByVal name As String)
        ' RETOURNE LE NOM DU DOSSIER CONTENANT LE JEU
        name = Replace(name, " ", "_")
        name = Replace(name, "/", "")
        name = Replace(name, "-", "")
        getFileName = name
        Return name
    End Function
    Function getCouplerCode(ByVal txt As String)
        Dim code As Integer
        Select Case txt
            Case "Ped to I 16ft" : code = 1100
            Case "Ped to I 8ft" : code = 1101
            Case "Ped to I 4ft" : code = 1102
            Case "Ped to II 16ft" : code = 1200
            Case "Ped to II 8ft" : code = 1201
            Case "Ped to II 4ft" : code = 1202
            Case "Ped to III 16ft" : code = 1300
            Case "Ped to III 8ft" : code = 1301
            Case "Ped to III 4ft" : code = 1302
            Case "I to Ped 16ft" : code = 1005
            Case "I to Ped 8ft" : code = 1006
            Case "I to Ped 4ft" : code = 1007
            Case "II to Ped 16ft" : code = 1010
            Case "II to Ped 8ft" : code = 1011
            Case "II to Ped 4ft" : code = 1012
            Case "III to Ped 16ft" : code = 1015
            Case "III to Ped 8ft" : code = 1016
            Case "III to Ped 4ft" : code = 1017
            Case "IV to Ped 8ft" : code = 1021
            Case "V to Ped 8ft" : code = 1026
            Case "I to I 16ft" : code = 1105
            Case "I to I Uni.Off" : code = 1106
            Case "I to I 4ft" : code = 1107
            Case "II to I 16ft" : code = 1110
            Case "II to I 8ft" : code = 1111
            Case "II to I 4ft" : code = 1112
            Case "II to II 16ft" : code = 1210
            Case "II to II Uni.Off" : code = 1211
            Case "II to II 4ft" : code = 1212
            Case "III to I 16ft" : code = 1115
            Case "III to I 8ft" : code = 1116
            Case "III to I 4ft" : code = 1117
            Case "III to I Melody" : code = 1119
            Case "III to II 16ft" : code = 1215
            Case "III to II 8ft" : code = 1216
            Case "III to II 4ft" : code = 1217
            Case "III to III 16ft" : code = 1315
            Case "III to III Uni.Off" : code = 1316
            Case "III to III 4ft" : code = 1317
            Case "IV to I 16ft" : code = 1120
            Case "IV to I 8ft" : code = 1121
            Case "IV to I 4ft" : code = 1122
            Case "IV to I Melody" : code = 1124
            Case "IV to II 16ft" : code = 1220
            Case "IV to II 8ft" : code = 1221
            Case "IV to II 4ft" : code = 1222
            Case "IV to III 16ft" : code = 1320
            Case "IV to III 8ft" : code = 1321
            Case "IV to III 4ft" : code = 1322
            Case "IV to IV 16ft" : code = 1420
            Case "IV to IV Uni.Off" : code = 1421
            Case "IV to IV 4ft" : code = 1422
            Case "V to I 16ft" : code = 1125
            Case "V to I 8ft" : code = 1126
            Case "V to I 4ft" : code = 1127
            Case "V to I Melody" : code = 1129
            Case "V to II 16ft" : code = 1225
            Case "V to II 8ft" : code = 1226
            Case "V to II 4ft" : code = 1227
            Case "V to III 16ft" : code = 1325
            Case "V to III 8ft" : code = 1326
            Case "V to III 4ft" : code = 1327
            Case "V to IV 16ft" : code = 1425
            Case "V to IV 8ft" : code = 1426
            Case "V to IV 4ft" : code = 1427
            Case "I to Ped Bass" : code = 1008
            Case "II to Ped Bass" : code = 1013
            Case "III to Ped Bass" : code = 1018
            Case "IV to Ped Bass" : code = 1023
            Case "V to Ped Bass" : code = 1028
        End Select
        Return code
    End Function
    Function GetTremulantCode(ByVal manual As Integer)
        Dim code As Integer
        code = 1700 + (manual * 10)
        Return code
    End Function
    Function getEnclosureCode(ByVal manual As Integer)
        Dim code As Integer
        code = 200 + (manual * 10)
        ' ajouter 1 pour tibia
        Return code
    End Function
    Function getManualNumber(ByVal idx)

        Select Case idx
            Case 1 To 16 ' PEDAL
                Return 0
            Case 17 To 32 'MANUAL 1
                Return 1
            Case 33 To 40
                ' SI UN A TROIS CLAVIERS
                If nbrOfManuals <= 3 Then Return 1 ' great
                ' SI 4 A CINQ CLAVIERS
                If nbrOfManuals >= 4 Then Return 2
            Case 41 To 48
                ' SI UN OU DEUX CLAVIER
                If nbrOfManuals <= 2 Then Return 1 ' great
                ' SI TROIS A CINQ CLAVIERS
                If nbrOfManuals >= 3 Then Return 2
            Case 49 To 64
                ' SI UN SEUL CLAVIER
                If nbrOfManuals = 1 Then Return 1
                ' SI DEUX CLAVIERS
                If nbrOfManuals = 2 Then Return 2
                ' SI TROIS CLAVIERS
                If nbrOfManuals = 3 Then Return 2
                ' SI 4 OU 5 CLAVIERS
                If nbrOfManuals >= 4 Then Return 3
            Case 65 To 80
                ' SI UN SEUL CLAVIER
                If nbrOfManuals = 1 Then Return 1
                ' SI DEUX CLAVIERS
                If nbrOfManuals = 2 Then Return 2
                ' SI TROIS CLAVIERS
                If nbrOfManuals = 3 Then Return 3
                ' SI 4 OU 5 CLAVIERS
                If nbrOfManuals >= 4 Then Return 4
            Case 81 To 96
                Return 5
        End Select
        Return -1 ' si echec
    End Function
    Private Sub ButtonRandomFill_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonRandomFill.Click
        ' SIMULE LA SELECTION D'UNE BOX PUIS D'UN STOP
        neverWarned = True
        ' EXPLORER LES BOX
        Dim ctrl As Control
        Dim idx As Integer = 0
        Dim alea As Integer
        Dim lastKnob As Integer = NumericAlea.Value
        ' RAZ
        clear_pBoxes()

        ' BOUCLE
        For Each ctrl In TabPage1.Controls
            If TypeOf ctrl Is PictureBox Then
                idx = ctrl.Tag
                If idx <= lastKnob Then
                    knob(idx).used = False
                    set_image_On(ctrl)
                    selectedKnob = ctrl
                    selectedKnobIndex = idx
                    alea = Int(Rnd() * 45) ' nombre de jeux
                    ManualStopsList.SelectedIndex = alea
                    If knob(idx).used = False Then set_image_Off(ctrl)
                End If
            End If
        Next
    End Sub
    Private Sub ButtonRandomFillHalf_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonRandomFillHalf.Click
        ' SIMULE LA SELECTION D'UNE BOX PUIS D'UN STOP SUR DEUX
        neverWarned = True
        ' EXPLORER LES BOX
        Dim ctrl As Control
        Dim idx As Integer = 0
        Dim alea As Integer
        Dim aleaHalf As Integer
        Dim lastKnob As Integer = NumericAlea.Value
        ' RAZ
        clear_pBoxes()

        ' BOUCLE
        For Each ctrl In TabPage1.Controls
            If TypeOf ctrl Is PictureBox Then
                idx = ctrl.Tag
                If idx <= lastKnob Then
                    aleaHalf = Int(Rnd() * 2)
                    If aleaHalf = 0 Then ' environ 1 sur 2
                        knob(idx).used = False
                        set_image_On(ctrl)
                        selectedKnob = ctrl
                        selectedKnobIndex = idx
                        alea = Int(Rnd() * 45)
                        ManualStopsList.SelectedIndex = alea
                        If knob(idx).used = False Then set_image_Off(ctrl)
                    End If
                End If
            End If
        Next
    End Sub

    Public Sub clear_pBoxes()
        Dim idx As Integer
        nbKnobsUsed = 0 : LabelKnobsUsed.Text = nbKnobsUsed
        nbStopsUsed = 0 : LabelStopsUsed.Text = nbStopsUsed
        For Each ctrl In TabPage1.Controls
            If TypeOf ctrl Is PictureBox Then
                idx = ctrl.Tag
                knob(idx).used = False
                knob(idx).isRank = False
                knob(idx).isPedalRank = False
                knob(idx).isCoupler = False
                knob(idx).isTremulant = False
                knob(idx).isTremulated = False
                set_image_Off(ctrl)
            End If
        Next
        needJamb2 = False
    End Sub
    Private Sub clear_tremulated_stops()
        ' procedure a utiliser avant search_tremulated_stops
        Dim idxtrem
        For idxtrem = 1 To 96
            knob(idxtrem).isTremulated = False
            knob(idxtrem).tremulantCode = 0
        Next
    End Sub
    Public Sub search_Tremulated_Stops()
        ' RECHERCHE LES JEUX QUI DOIVENT ETRE TREMULES
        ' EXAMINE UNE LIGNE DE HUIT KNOBS
        Dim idx1 As Integer
        Dim idx2 As Integer
        Dim idx3 As Integer
        Dim line_tremulated As Boolean
        Dim manual_to_trem As Short ' clavier a tremuler

        ' raz d'abord
        clear_tremulated_stops()

        ' BOUCLE
        For idx1 = 1 To 96 Step 8
            line_tremulated = False
            For idx2 = 0 To 7
                If knob(idx1 + idx2).isTremulant Then
                    'MsgBox((idx1 + idx2).ToString & " is Tremulant" & vbCrLf & (idx1).ToString & " a " & (idx1 + 7).ToString & " are Tremulated")
                    line_tremulated = True
                    manual_to_trem = knob(idx1 + idx2).manual ' en prevision de entire manual à tremuler

                    ' SI LIGNE TREMULEE, TOUS LES JEUX DE LA LIGNE SONT TREMULABLES
                    For idx3 = 0 To 7
                        knob(idx1 + idx3).isTremulated = line_tremulated
                        knob(idx1 + idx3).tremulantCode = GetTremulantCode(knob(idx1 + idx3).manual)
                    Next
                    ' SI RADIO TREM ENTIRE MANUAL EST COCHE TOUT LE CLAVIER DOIT ETRE TREMULE
                    If RadioTremEntireManual.Checked = True Then
                        Dim idxtrem As Short
                        For idxtrem = 1 To 96
                            If knob(idxtrem).manual = manual_to_trem Then
                                knob(idxtrem).isTremulated = True
                                knob(idxtrem).tremulantCode = GetTremulantCode(knob(idxtrem).manual)
                            End If
                        Next
                    End If
                End If
            Next
        Next
    End Sub

    ' JAMBS
    Public Sub compute_drawstops_location()
        Dim idx As Single
        Const x0 = 105
        Dim xx As Single = x0
        Dim yy As Single ' = 115

        '
        set_jamb_buttons()

        needJamb2 = True
        '
        xx = x0 : yy = 560
        For idx = 1 To 8
            With knob(idx)
                If .used Then .loc2.X = xx : .loc2.Y = yy : .jamb = 2
                xx += 112
            End With
        Next
        xx = x0 : yy = 453
        For idx = 9 To 16
            With knob(idx)
                If .used Then .loc2.X = xx : .loc2.Y = yy : .jamb = 2
                xx += 112
            End With
        Next
        xx = x0 : yy = 346
        For idx = 17 To 24
            With knob(idx)
                If .used Then .loc2.X = xx : .loc2.Y = yy : .jamb = 2
                xx += 112
            End With
        Next
        xx = x0 : yy = 239
        For idx = 25 To 32
            With knob(idx)
                If .used Then .loc2.X = xx : .loc2.Y = yy : .jamb = 2
                xx += 112
            End With
        Next
        xx = x0 : yy = 132
        For idx = 33 To 40
            With knob(idx)
                If .used Then .loc2.X = xx : .loc2.Y = yy : .jamb = 2
                xx += 112
            End With
        Next
        xx = x0 : yy = 25
        For idx = 41 To 48
            With knob(idx)
                If .used Then .loc2.X = xx : .loc2.Y = yy : .jamb = 2
                xx += 112
            End With
        Next
        '
        ' JAMBE DROITE
        xx = x0 : yy = 560
        For idx = 49 To 56
            With knob(idx)
                If .used Then .loc2.X = xx : .loc2.Y = yy : .jamb = 3
                xx += 112
            End With
        Next
        xx = x0 : yy = 453
        For idx = 57 To 64
            With knob(idx)
                If .used Then .loc2.X = xx : .loc2.Y = yy : .jamb = 3
                xx += 112
            End With
        Next
        xx = x0 : yy = 346
        For idx = 65 To 72
            With knob(idx)
                If .used Then .loc2.X = xx : .loc2.Y = yy : .jamb = 3
                xx += 112
            End With
        Next
        xx = x0 : yy = 239
        For idx = 73 To 80
            With knob(idx)
                If .used Then .loc2.X = xx : .loc2.Y = yy : .jamb = 3
                xx += 112
            End With
        Next
        xx = x0 : yy = 132
        For idx = 81 To 88
            With knob(idx)
                If .used Then .loc2.X = xx : .loc2.Y = yy : .jamb = 3
                xx += 112
            End With
        Next
        xx = x0 : yy = 25
        For idx = 89 To 96
            With knob(idx)
                If .used Then .loc2.X = xx : .loc2.Y = yy : .jamb = 3
                xx += 112
            End With
        Next


    End Sub

    Public Sub set_jamb_buttons()
        ' PARAMETRES SELON TYPE DE BOUTONS
        If RadioButton1.Checked = True Then
            jambButtonOn = "knob72on.bmp"
            jambButtonOff = "knob72off.bmp"
            jambButtonMask = "knob72mask.bmp"
            jambButtonID = 6
        End If
        If RadioButton2.Checked = True Then
            jambButtonOn = "knob84on.bmp"
            jambButtonOff = "knob84off.bmp"
            jambButtonMask = "knob84mask.bmp"
            jambButtonID = 7
        End If
        If RadioButton3.Checked = True Then
            jambButtonOn = "roundknob84on.bmp"
            jambButtonOff = "roundknob84off.bmp"
            jambButtonMask = "roundknob84mask.bmp"
            jambButtonID = 8
        End If
        If RadioButton4.Checked = True Then
            jambButtonOn = "tab-white-on.bmp"
            jambButtonOff = "tab-white-off.bmp"
            jambButtonMask = "tab-white-mask.bmp"
            jambButtonID = 9
        End If

    End Sub
    Sub compute_location_in_jambs()
        compute_drawstops_location()
        Exit Sub


        Dim rectW As Integer
        Dim rectH As Integer
        Const topX As Integer = 50
        Const topY As Integer = 40
        Dim posX As Integer = topX
        Dim posY As Integer = topY
        Dim Man As Integer = 0 ' start with pedal
        ' PARAMETRES SELON TYPE DE BOUTONS
        If RadioButton1.Checked = True Then
            rectW = 75 : rectH = 75 ' dimensions de l'objet + 3 pixels
            jambButtonOn = "knob72on.bmp"
            jambButtonOff = "knob72off.bmp"
            jambButtonMask = "knob72mask.bmp"
            jambButtonID = 6
        End If
        If RadioButton2.Checked = True Then
            rectW = 88 : rectH = 88
            jambButtonOn = "knob84on.bmp"
            jambButtonOff = "knob84off.bmp"
            jambButtonMask = "knob84mask.bmp"
            jambButtonID = 7
        End If
        If RadioButton3.Checked = True Then
            rectW = 88 : rectH = 88
            jambButtonOn = "roundknob84on.bmp"
            jambButtonOff = "roundknob84off.bmp"
            jambButtonMask = "roundknob84mask.bmp"
            jambButtonID = 8
        End If
        If RadioButton4.Checked = True Then
            rectW = 84 : rectH = 104
            jambButtonOn = "tab-white-on.bmp"
            jambButtonOff = "tab-white-off.bmp"
            jambButtonMask = "tab-white-mask.bmp"
            jambButtonID = 9
        End If

        ' 1ER LABEL PEDAL
        label(nbrOfLabels).isUsed = True
        label(nbrOfLabels).name = "Label " & nbrOfLabels.ToString
        label(nbrOfLabels).text = "PED."
        label(nbrOfLabels).posX = topX + 30
        label(nbrOfLabels).posY = topY - 22
        label(nbrOfLabels).page = 2 ' jamb gauche
        nbrOfLabels += 1

        ' BOUCLE
        Dim idx
        For idx = 0 To 96
            With knob(idx)
                If .used = True Then
                    If .manual = Man Then ' NE PAS CHANGER DE COLONNE (SAUF SI BAS ATTEINT)
                        .loc2.X = posX
                        .loc2.Y = posY
                        posY += rectH ' descendre pour le prochain
                        If posY > 620 Then ' saut de colonne, meme clavier
                            posY = topY
                            posX += rectW
                            .loc2.X = posX
                            .loc2.Y = posY
                            posY += rectH ' descendre
                        End If
                    Else ' MANUAL  SUIVANT --> PASSER A COLONNE SUIVANTE
                        posY = topY
                        posX += rectW
                        ' NOUVEAU LABEL
                        label(nbrOfLabels).isUsed = True
                        label(nbrOfLabels).name = "Label " & nbrOfLabels.ToString
                        If .manual = 0 Then
                            label(nbrOfLabels).text = "PED."
                        Else
                            label(nbrOfLabels).text = "MAN. " & .manual.ToString
                        End If
                        label(nbrOfLabels).posX = posX + 30
                        label(nbrOfLabels).posY = topY - 22
                        label(nbrOfLabels).page = 2 ' jamb gauche

                        ' SI BESOIN PRENDRE UNE AUTRE JAMB
                        If posX > 920 Then
                            needJamb2 = True
                        End If
                        If needJamb2 = True Then
                            label(nbrOfLabels).page = 3 ' jamb droite
                        End If
                        nbrOfLabels += 1
                        .loc2.X = posX
                        .loc2.Y = posY
                        posY += rectH ' descendre

                        Man = .manual
                    End If

                End If
            End With
        Next

    End Sub
    Private Sub ButtonLocationJamb_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonLocationJamb.Click
        ' POUR MISE AU POINT
        compute_location_in_jambs()
        Dim idx
        RTBox.Text = ""
        For idx = 0 To 95
            With knob(idx)
                If .used = True Then
                    RTBox.Text += idx.ToString & "  " & .name & "   " & .manual & "   x=" & .loc2.X.ToString & "   y=" & .loc2.Y.ToString
                    RTBox.Text += vbCrLf
                End If
            End With
        Next

    End Sub

    ' TAB PAGE 5 (HELP)
    Private Sub ButtonHelpEnglish_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonHelpEnglish.Click
        load_english_help()
    End Sub
    Private Sub load_english_help()
        Dim fichier As String = ""
        Try
            fichier = "help_english_004.rtf"
            RTBoxHelp.LoadFile(App_Path() & fichier)
        Catch
            MsgBox(fichier & " not found")
        End Try
    End Sub
    Private Sub ButtonHelpFrench_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonHelpFrench.Click
        Dim fichier As String = ""
        Try
            fichier = "help_french_004.rtf"
            RTBoxHelp.LoadFile(App_Path() & fichier)
        Catch
            MsgBox("Fichier " & fichier & " non trouvé")
        End Try
    End Sub

    Private Sub Button_Clear_Last_Knob(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonClearLastKnob.Click
        Dim pbox As PictureBox = selectedKnob
        set_image_Off(pbox)
        If knob(selectedKnobIndex).used = True Then
            knob(selectedKnobIndex).used = False
            If knob(selectedKnobIndex).isRank Then
                nbStopsUsed += -1 : LabelStopsUsed.Text = nbStopsUsed.ToString
            End If
            knob(selectedKnobIndex).isRank = False
            knob(selectedKnobIndex).isCoupler = False
            knob(selectedKnobIndex).isTremulant = False
            nbKnobsUsed += -1 : LabelKnobsUsed.Text = nbKnobsUsed.ToString
        End If
    End Sub

    ' DEMOS
    Private Sub ButtonDemo1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonDemo1.Click
        ' DEMO 1 CLAVIER
        NumericNbrOfManuals.Value = 1
        clear_pBoxes()

        assignStop(PictureBox1, "Bombarde 16")
        assignStop(PictureBox2, "Principal 16")
        assignStop(PictureBox3, "Soubasse 16")
        assignStop(PictureBox4, "Trompette 8")
        assignStop(PictureBox5, "Basse 8")
        assignStop(PictureBox6, "Bourdon 8")

        assignStop(PictureBox17, "Bourdon 16")
        assignStop(PictureBox18, "Montre 16")
        assignStop(PictureBox19, "Bourdon 8")
        assignStop(PictureBox20, "Montre 8")
        assignStop(PictureBox21, "Flute Cheminee 8")
        assignStop(PictureBox22, "Cromorne 8")
        assignStop(PictureBox23, "Cor de Chamois 8")
        assignStop(PictureBox24, "Gambe 8")
        assignStop(PictureBox25, "Celeste 8")
        assignStop(PictureBox26, "Hautbois 8")
        assignStop(PictureBox27, "Trompette 8")
        assignStop(PictureBox28, "Prestant 4")
        assignStop(PictureBox29, "Cor de Chamois 4")
        assignStop(PictureBox30, "Flute Fuseau 4")
        assignStop(PictureBox31, "Flute Harm. 4")
        assignStop(PictureBox32, "Clairon 4")
        assignStop(PictureBox38, "Cornet III")
        assignStop(PictureBox34, "Doublette 2")
        assignStop(PictureBox33, "Quinte 2-2/3")
        assignStop(PictureBox37, "Larigot 1-1/3")
        assignStop(PictureBox40, "Cymbale III")
        assignStop(PictureBox35, "Flute Con. 2")
        assignStop(PictureBox36, "Tierce 1-3/5")
        assignStop(PictureBox39, "Mixture IV")
        ' COUPLERS
        assignCoupler(PictureBox48, "I to Ped 8ft")
    End Sub
    Private Sub ButtonDemo2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonDemo2.Click
        ' DEMO 2 CLAVIERS
        NumericNbrOfManuals.Value = 2
        clear_pBoxes()

        assignStop(PictureBox1, "Bombarde 16")
        assignStop(PictureBox2, "Principal 16")
        assignStop(PictureBox3, "Soubasse 16")
        assignStop(PictureBox4, "Trompette 8")
        assignStop(PictureBox5, "Basse 8")
        assignStop(PictureBox6, "Bourdon 8")
        assignStop(PictureBox7, "Prestant 4")
        assignStop(PictureBox8, "Clairon 4")

        assignStop(PictureBox17, "Trompette 16")
        assignStop(PictureBox18, "Montre 16")
        assignStop(PictureBox19, "Bourdon 8")
        assignStop(PictureBox20, "Montre 8")
        assignStop(PictureBox21, "Flute Cheminee 8")
        assignStop(PictureBox22, "Cromorne 8")
        assignStop(PictureBox23, "Cor de Chamois 8")
        'assignStop(PictureBox24, "Gambe 8")
        'assignStop(PictureBox25, "Celeste 8")
        'assignStop(PictureBox26, "Hautbois 8")
        assignStop(PictureBox27, "Trompette 8")
        assignStop(PictureBox28, "Prestant 4")
        assignStop(PictureBox29, "Cor de Chamois 4")
        assignStop(PictureBox30, "Flute Fuseau 4")
        assignStop(PictureBox31, "Flute Harm. 4")
        assignStop(PictureBox32, "Clairon 4")
        assignStop(PictureBox38, "Cornet III")
        assignStop(PictureBox34, "Doublette 2")
        assignStop(PictureBox33, "Quinte 2-2/3")
        assignStop(PictureBox37, "Larigot 1-1/3")
        assignStop(PictureBox40, "Cymbale III")
        assignStop(PictureBox35, "Flute Con. 2")
        assignStop(PictureBox36, "Tierce 1-3/5")
        assignStop(PictureBox39, "Mixture IV")

        'assignstop(picturebox  ,("Gambe 16")
        assignStop(PictureBox50, "Basson 16")
        'assignstop(picturebox  ,("Montre 16")
        assignStop(PictureBox49, "Bourdon 16")
        'assignstop(picturebox  ,("Quintaton 16")
        ' assignstop(picturebox  ,("Clarinette 16")
        'assignstop(picturebox  ,("Montre 8")
        assignStop(PictureBox51, "Flute Douce 8")
        'assignstop(picturebox  ,("Flute Cheminee 8")
        assignStop(PictureBox52, "Gambe 8")
        assignStop(PictureBox55, "Quintaton 8")
        ' assignstop(picturebox  ,("Cor de Chamois 8")
        'assignstop(picturebox  ,("Principal 8")
        ' assignstop(picturebox  ,("Viole de Gambe 8")
        'assignstop(picturebox  ,("Salicional 8")
        'assignstop(picturebox  ,("Bourdon 8")
        'assignstop(picturebox  ,("Trompette 8")
        assignStop(PictureBox53, "Celeste 8")
        'assignstop(picturebox  ,("Undamaris 8")
        ' assignstop(picturebox  ,("Dulciane 8")
        'assignstop(picturebox  ,("Cromorne 8")
        assignStop(PictureBox58, "Hautbois 8")
        assignStop(PictureBox57, "Voix Humaine 8")
        assignStop(PictureBox54, "Tuba 8")

        'assignstop(picturebox  ,("Cor de Chamois 4")
        assignStop(PictureBox59, "Flute Trav. 4")
        ' assignstop(picturebox  ,("Flute Harm. 4")
        'assignstop(picturebox  ,("Flute fuseau 4")
        'assignstop(picturebox  ,("Flute 4")
        'assignstop(picturebox  ,("Principal 4")
        'assignstop(picturebox  ,("Fourniture IV")
        assignStop(PictureBox60, "Clairon 4")
        'assignstop(picturebox  ,("Cornet III")
        'assignstop(picturebox  ,("Doublette 2")
        'assignstop(picturebox  ,("Quinte 2-2/3")
        assignStop(PictureBox63, "Larigot 1-1/3")
        'assignstop(picturebox  ,("Sesquialtera")
        'assignstop(picturebox  ,("Piccolo 1") ' sifflet
        ''assignstop(picturebox  ,("Cymbale III")
        assignStop(PictureBox61, "Flute Con. 2")
        assignStop(PictureBox62, "Tierce 1-3/5")
        'assignstop(picturebox  ,("Tierce 3-1/5")
        'assignstop(picturebox  ,("Nasard 2-2/3")
        'assignstop(picturebox  ,("Quinte 5-1/3")
        'assignstop(picturebox  ,("Septade 1-1/7")
        'assignstop(picturebox  ,("Mixture IV")
        'assignstop(picturebox  ,("Clarinette 8")
        ' COUPLERS
        assignCoupler(PictureBox48, "I to Ped 8ft")
        assignCoupler(PictureBox72, "II to Ped 8ft")
        assignCoupler(PictureBox71, "II to I 4ft")
        assignCoupler(PictureBox70, "II to I 8ft")
        assignCoupler(PictureBox69, "II to I 16ft")

    End Sub
    Private Sub ButtonDemo3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonDemo4.Click
        ' DEMO 3 CLAVIERS
        NumericNbrOfManuals.Value = 3
        clear_pBoxes()

        assignStop(PictureBox1, "Principal 32")
        assignStop(PictureBox2, "Bombarde 16")
        assignStop(PictureBox3, "Principal 16")
        assignStop(PictureBox4, "Soubasse 16")
        assignStop(PictureBox5, "Trompette 8")
        assignStop(PictureBox6, "Basse 8")
        assignStop(PictureBox7, "Bourdon 8")
        assignStop(PictureBox8, "Prestant 4")
        assignStop(PictureBox9, "Clairon 4")

        ' MANUAL 1
        assignStop(PictureBox17, "Trompette 16")
        assignStop(PictureBox18, "Montre 16")
        assignStop(PictureBox19, "Bourdon 8")
        assignStop(PictureBox20, "Montre 8")
        assignStop(PictureBox21, "Flute Cheminee 8")
        assignStop(PictureBox22, "Cromorne 8")
        assignStop(PictureBox23, "Cor de Chamois 8")
        assignStop(PictureBox25, "Dulciane 8")
        assignStop(PictureBox27, "Trompette 8")
        assignStop(PictureBox28, "Prestant 4")
        assignStop(PictureBox29, "Cor de Chamois 4")
        assignStop(PictureBox30, "Flute Fuseau 4")
        assignStop(PictureBox31, "Flute Harm. 4")
        assignStop(PictureBox32, "Clairon 4")
        assignStop(PictureBox38, "Cornet III")
        assignStop(PictureBox34, "Doublette 2")
        assignStop(PictureBox33, "Quinte 2-2/3")
        assignStop(PictureBox37, "Larigot 1-1/3")
        assignStop(PictureBox40, "Cymbale III")
        assignStop(PictureBox35, "Flute Con. 2")
        assignStop(PictureBox36, "Tierce 1-3/5")
        assignStop(PictureBox39, "Mixture IV")

        ' MANUAL 2
        assignStop(PictureBox50, "Basson 16")
        assignStop(PictureBox49, "Bourdon 16")
        assignStop(PictureBox51, "Flute Douce 8")
        assignStop(PictureBox52, "Gambe 8")
        assignStop(PictureBox55, "Quintaton 8")
        assignStop(PictureBox53, "Celeste 8")
        assignStop(PictureBox58, "Hautbois 8")
        assignStop(PictureBox57, "Voix Humaine 8")
        assignStop(PictureBox54, "Tuba 8")
        assignStop(PictureBox59, "Flute Trav. 4")
        assignStop(PictureBox60, "Clairon 4")
        assignStop(PictureBox63, "Larigot 1-1/3")
        assignStop(PictureBox61, "Flute Con. 2")
        assignStop(PictureBox62, "Tierce 1-3/5")
        'assignstop(picturebox  ,"Quintaton 16")
        ' assignstop(picturebox  ,"Clarinette 16")
        'assignstop(picturebox  ,"Principal 8")
        ' assignstop(picturebox  ,"Viole de Gambe 8")
        'assignstop(picturebox  ,"Flute 4")
        'assignstop(picturebox  "Principal 4")
        'assignstop(picturebox  ,"Fourniture IV")
        'assignstop(picturebox  ,"Tierce 3-1/5")
        'assignstop(picturebox  ,"Nasard 2-2/3")
        'assignstop(picturebox  ,"Quinte 5-1/3")
        'assignstop(picturebox  ,"Septade 1-1/7")
        'assignstop(picturebox  ,"Piccolo 1") ' sifflet

        ' MANUAL 3
        assignStop(PictureBox65, "Gambe 16")
        assignStop(PictureBox66, "Flute Cheminee 8")
        assignStop(PictureBox67, "Clarinette 8")
        assignStop(PictureBox68, "Salicional 8")
        assignStop(PictureBox69, "Undamaris 8")
        assignStop(PictureBox70, "Flute fuseau 4")
        assignStop(PictureBox71, "Sesquialtera")

        ' COUPLERS
        assignCoupler(PictureBox24, "I to Ped 8ft")
        assignCoupler(PictureBox48, "II to Ped 8ft")
        assignCoupler(PictureBox47, "II to I 4ft")
        assignCoupler(PictureBox46, "II to I 8ft")
        assignCoupler(PictureBox45, "II to I 16ft")
        assignCoupler(PictureBox80, "III to Ped")
        assignCoupler(PictureBox79, "III to I 4ft")
        assignCoupler(PictureBox78, "III to I 8ft")
        assignCoupler(PictureBox77, "III to I 16ft")
        assignCoupler(PictureBox76, "III to II 4ft")
        assignCoupler(PictureBox75, "III to II 8ft")
        assignCoupler(PictureBox74, "III to II 16ft")



    End Sub
    Private Sub ButtonDemo4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        ' DEMO 4 MANUALS
        If registered = False Then
            MsgBox("Registered version only")
            Exit Sub
        End If

        NumericNbrOfManuals.Value = 4
        clear_pBoxes()

        assignStop(PictureBox1, "Principal 32")
        assignStop(PictureBox2, "Bombarde 16")
        assignStop(PictureBox3, "Principal 16")
        assignStop(PictureBox4, "Soubasse 16")
        assignStop(PictureBox5, "Trompette 8")
        assignStop(PictureBox6, "Basse 8")
        assignStop(PictureBox7, "Bourdon 8")
        assignStop(PictureBox8, "Prestant 4")
        assignStop(PictureBox9, "Clairon 4")

        ' MANUAL 1
        assignStop(PictureBox17, "Trompette 16")
        assignStop(PictureBox18, "Montre 16")
        assignStop(PictureBox19, "Bourdon 8")
        assignStop(PictureBox20, "Montre 8")
        assignStop(PictureBox21, "Flute Cheminee 8")
        assignStop(PictureBox22, "Cromorne 8")
        assignStop(PictureBox23, "Cor de Chamois 8")
        assignStop(PictureBox25, "Dulciane 8")
        assignStop(PictureBox26, "Trompette 8")
        assignStop(PictureBox27, "Fourniture V")
        assignStop(PictureBox28, "Prestant 4")
        assignStop(PictureBox29, "Cor de Chamois 4")
        assignStop(PictureBox30, "Flute Fuseau 4")
        assignStop(PictureBox31, "Flute Harm. 4")
        assignStop(PictureBox32, "Clairon 4")
        assignStop(PictureBox38, "Cornet III")
        ' MANUAL 2
        assignStop(PictureBox34, "Doublette 2")
        assignStop(PictureBox33, "Quinte 2-2/3")
        assignStop(PictureBox37, "Larigot 1-1/3")
        assignStop(PictureBox40, "Cymbale III")
        assignStop(PictureBox35, "Flute Con. 2")
        assignStop(PictureBox36, "Tierce 1-3/5")
        assignStop(PictureBox39, "Mixture IV")
        assignStop(PictureBox41, "Bourdon 16")
        assignStop(PictureBox42, "Basson 16")
        assignStop(PictureBox43, "Flute Douce 8")
        assignStop(PictureBox44, "Gambe 8")

        ' MANUAL 3
        assignStop(PictureBox53, "Celeste 8")
        assignStop(PictureBox54, "Tuba 8")
        assignStop(PictureBox55, "Septade 1-1/7")
        assignStop(PictureBox57, "Voix Humaine 8")
        assignStop(PictureBox58, "Hautbois 8")
        assignStop(PictureBox59, "Flute Trav. 4")
        assignStop(PictureBox60, "Clairon 4")
        assignStop(PictureBox61, "Flute Con. 2")
        assignStop(PictureBox62, "Tierce 1-3/5")
        assignStop(PictureBox63, "Larigot 1-1/3")
        assignStop(PictureBox64, "Piccolo 1") ' sifflet

        'assignstop(picturebox  ,"Quintaton 16")
        ' assignstop(picturebox  ,"Clarinette 16")
        'assignstop(picturebox  ,"Principal 8")
        'assignstop(picturebox  ,"Quintaton 8")
        ' assignstop(picturebox  ,"Viole de Gambe 8")
        'assignstop(picturebox  ,"Flute 4")
        'assignstop(picturebox  "Principal 4")
        'assignstop(picturebox  ,"Fourniture IV")
        'assignstop(picturebox  ,"Tierce 3-1/5")
        'assignstop(picturebox  ,"Nasard 2-2/3")
        'assignstop(picturebox  ,"Quinte 5-1/3")
        'assignstop(picturebox  ,"Piccolo 1") ' sifflet

        ' MANUAL 4
        assignStop(PictureBox65, "Gambe 16")
        assignStop(PictureBox66, "Flute Cheminee 8")
        assignStop(PictureBox67, "Clarinette 8")
        assignStop(PictureBox68, "Salicional 8")
        assignStop(PictureBox69, "Undamaris 8")
        assignStop(PictureBox70, "Flute fuseau 4")
        assignStop(PictureBox71, "Sesquialtera")
        ' COUPLERS
        assignCoupler(PictureBox24, "I to Ped 8ft")
        assignCoupler(PictureBox48, "II to Ped 8ft")
        assignCoupler(PictureBox47, "II to I 4ft")
        assignCoupler(PictureBox46, "II to I 8ft")
        assignCoupler(PictureBox45, "II to I 16ft")
        assignCoupler(PictureBox56, "III to I 8ft")
        assignCoupler(PictureBox80, "IV to Ped 8ft")
        assignCoupler(PictureBox79, "IV to I 8ft")
        assignCoupler(PictureBox78, "IV to II 8ft")
        assignCoupler(PictureBox77, "IV to III 8ft")

    End Sub

    Sub assignStop(ByVal pbox As PictureBox, ByVal stopName As String)
        ' ECRIT INFOS DANS TABLEAU KNOB()
        Dim knobIdx As Short = pbox.Tag
        set_image_On(pbox)
        With knob(knobIdx)
            .used = True
            .name = stopName
            .isRank = True
            .isCoupler = False
            .isTremulant = False
            If CheckBoxNameInCaps.Checked = True Then .name = .name.ToUpper
            .folder = getFileName(.name)
            .manual = getManualNumber(knobIdx)
            .enclosureCode = getEnclosureCode(.manual)
            LabelManual.Text = .manual.ToString
            .stopcode = 2000 + (100 * .manual) + knobIdx
            .loc1 = pbox.Location
            Select Case knobIdx
                Case Is < 17 : .subFolder = "Pedals" : .numberOfPipes = pedalsNbrOfPipes : .isPedalRank = True
                Case Else : .subFolder = "Manuals" : .numberOfPipes = manualsNbrOfPipes
            End Select
        End With
        nbKnobsUsed += 1 : LabelKnobsUsed.Text = nbKnobsUsed.ToString
        nbStopsUsed += 1 : LabelStopsUsed.Text = nbStopsUsed.ToString
        pbox.Refresh() ' OBLIGATOIRE : force l'execution de l'event PAINT


    End Sub
    Sub assignReloadStop(ByVal pbox As PictureBox, ByVal stopName As String, ByVal knobCode As String)
        ' ECRIT INFOS DANS TABLEAU KNOB()
        Dim knobIdx As Short = pbox.Tag
        set_image_On(pbox)
        With knob(knobIdx)
            .used = True
            .name = stopName
            .isRank = True
            .isPedalRank = IIf(knobCode = "P", True, False)
            .isCoupler = False
            .isTremulant = False
            If CheckBoxNameInCaps.Checked = True Then .name = .name.ToUpper
            .folder = getFileName(.name)
            .manual = getManualNumber(knobIdx)
            Select Case .manual
                Case 0 : .numberOfPipes = pedalsNbrOfPipes
                Case Else : .numberOfPipes = manualsNbrOfPipes
            End Select
            .enclosureCode = getEnclosureCode(.manual)
            LabelManual.Text = .manual.ToString
            .stopcode = 2000 + (100 * .manual) + knobIdx
            .loc1 = pbox.Location
            Select Case .isPedalRank
                Case True : .subFolder = "Pedals" ': .numberOfPipes = pedalsNbrOfPipes
                Case False : .subFolder = "Manuals" ' : .numberOfPipes = manualsNbrOfPipes
            End Select
        End With
        nbKnobsUsed += 1 : LabelKnobsUsed.Text = nbKnobsUsed.ToString
        nbStopsUsed += 1 : LabelStopsUsed.Text = nbStopsUsed.ToString
        pbox.Refresh() ' OBLIGATOIRE : force l'execution de l'event PAINT


    End Sub
    Sub assignCoupler(ByVal pbox As PictureBox, ByVal couplerName As String)
        ' ECRIT INFOS DANS TABLEAU KNOB()
        Dim knobIdx As Short = pbox.Tag
        set_image_On(pbox)
        With knob(knobIdx)
            .used = True
            .name = couplerName
            .isRank = False
            .isCoupler = True
            .isTremulant = False
            If CheckBoxNameInCaps.Checked = True Then .name = .name.ToUpper
            '.folder = getFileName(.name)
            .manual = getManualNumber(knobIdx)
            ' .enclosureCode = getEnclosureCode(.manual)
            LabelManual.Text = "" ' .manual.ToString
            '.stopcode = 2000 + (100 * .manual) + knobIdx
            .loc1 = pbox.Location

        End With
        nbKnobsUsed += 1 : LabelKnobsUsed.Text = nbKnobsUsed.ToString
        'nbStopsUsed += 1 : LabelStopsUsed.Text = nbStopsUsed.ToString
        pbox.Refresh() ' OBLIGATOIRE : force l'execution de l'event PAINT
    End Sub

    Private Sub Button1_how_register(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonHowRegister.Click
        MsgBox("To register Basilica, please send 30 € to my Paypal account : VERPEAUXJP@HOTMAIL.FR " & vbCrLf _
               & "You will receive within 2 or 3 days your login and password" & vbCrLf _
               & "Pour obtenir une version enregistrée, merci d'envoyer 30 € sur mon compte Paypal : VERPEAUXJP@HOTMAIL.FR " & vbCrLf _
               & "Vous receevrez sous 3 jours maximum votre login et mot de passe.")

    End Sub


   
    Private Sub ButtonReloadCodf_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonReloadCodf.Click
        RtbCODF.Text = ""
        LabelCodfInfo.Text = ""
        clear_pBoxes()
        reload_CODF()
    End Sub

    Private Sub ButtonInitAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonInitAll.Click
        init_all()
    End Sub
End Class
