﻿Module register
    Public registered As Boolean = False ' = False par defaut
    Public author As Boolean = False ' true seulement si c'est ma version perso
    Public versionInfo = My.Application.Info.Version
    Public version As String = versionInfo.major & "-" & versionInfo.minor & "-" & versionInfo.build
    Public licenseFile As String = ""
    Public licenseUser As String = ""
    Public licenseKey As String = ""

    Public Sub check_if_registered()

        'registred = False ' par defaut

        Main.Text = "BASILICA version " & version & " DEMO VERSION (unregistered)."
        Try
            ' 1) unregistred si fichier data\licence.txt absent
            licenseFile = Application.StartupPath & "\licenseKey.txt"
            If Not My.Computer.FileSystem.FileExists(licenseFile) Then
                Main.Text = "BASILICA version " & version & " ( DEMO VERSION because the File License.txt is missing)"
                Exit Sub
            End If
            '2) lire licenceUser et licensekey
            FileOpen(1, licenseFile, OpenMode.Input)
            ' licenseUser est le texte inscit dans la 1e ligne du fichier licFile
            licenseUser = LineInput(1).ToUpper
            ' licensekey est le nombre inscit dans la 2e ligne du fichier licFile
            licenseKey = Val(LineInput(1))
            FileClose(1)
            '2) il faut au moins 6 lettres
            If Len(licenseUser) < 6 Then MsgBox("Wrong user's license") : End

            '3) calculer si concordance
            Dim waitedKey As Double ' nombre attendu
            Dim readChar As String ' caractere lu
            readChar = Microsoft.VisualBasic.Left$(licenseUser, 1).ToUpper
            waitedKey = Asc(readChar) * 345
            readChar = Microsoft.VisualBasic.Mid$(licenseUser, 2, 1).ToUpper
            waitedKey += Asc(readChar) * 39
            readChar = Microsoft.VisualBasic.Mid$(licenseUser, 3, 1).ToUpper
            waitedKey *= Asc(readChar) * 5
            readChar = Microsoft.VisualBasic.Mid$(licenseUser, 4, 1).ToUpper
            waitedKey += Asc(readChar) * 2
            readChar = Microsoft.VisualBasic.Mid$(licenseUser, 5, 1).ToUpper
            waitedKey *= Asc(readChar) * 7
            readChar = Microsoft.VisualBasic.Mid$(licenseUser, 6, 1).ToUpper
            waitedKey *= Asc(readChar) * 13
            ' MsgBox(waitedKey)

            If author = True Then
                registered = True
                Main.Text = "BASILICA version " & version & " registered as AUTHOR"
                Exit Sub
            End If
            ' CODE CORRECT ,
            If licenseKey = waitedKey Then
                registered = True
                author = False
                Main.Text = "BASILICA version " & version & "  REGISTERED VERSION (Owner : " & licenseUser & ")"
                Main.TextBoxLogin.BackColor = Color.LightGreen
                Main.TextBoxCode.BackColor = Color.LightGreen
                Main.ButtonHowRegister.Visible = False
                Main.LabelRegister.Text = "REGISTRED"
            Else
                ' TOUS LES AUTRES CAS
                registered = False
                author = False
                Main.Text = "BASILICA " & version & "  UNREGISTERED VERSION"
                Main.TextBoxLogin.BackColor = Color.LightPink

                Main.TextBoxCode.BackColor = Color.LightPink

            End If
        Catch exc As Exception
            MsgBox(exc.Message)
        End Try
    End Sub
End Module
