﻿Imports System.IO ' pour lecture eciture fichiers
Module fichiers
    Public customOrgansPath As String
    Public Function App_Path() As String
        Return System.AppDomain.CurrentDomain.BaseDirectory()
    End Function
    Public Sub readCustomOrganPath(ByVal fichier As String)

        Try
            ' Création d'une instance de StreamReader pour permettre la lecture de notre fichier
            Dim monStreamReader As StreamReader = New StreamReader(App_Path() & fichier)
            customOrgansPath = monStreamReader.ReadLine()
            'Fermeture du StreamReader (attention très important)
            monStreamReader.Close()

        Catch ex As Exception
            'Code exécuté en cas d'exception
        End Try
    End Sub
    Sub saveCodfPath(ByVal fichier As String)

        Try
            'Instanciation du StreamWriter avec passage du nom du fichier 
            Dim monStreamWriter As StreamWriter = New StreamWriter(App_Path() & fichier)
            'Ecriture du texte dans votre fichier
            monStreamWriter.WriteLine(customOrgansPath)
            'Fermeture du StreamWriter (Trés important)
            monStreamWriter.Close()

        Catch ex As Exception

            MsgBox("Error : I cannot write your CODF path in the file" & App_Path() & fichier)
        End Try

    End Sub

    Public Sub reload_CODF()
        Dim ligne As String = "start"
        Dim file As String
        Dim knobID As String
        Dim knobName As String
        Dim knobtype As String = ""
        Dim pbox As PictureBox
        file = customOrgansPath & "/"
        file += OrganDefinitionFilename
        file += ".CustomOrgan_Hauptwerk_xml"

        Main.OpenFileDialog1.Title = "Open a CODF made by Basilica"
        Main.OpenFileDialog1.DefaultExt = ".CustomOrgan_Hauptwerk_xml"
        Main.OpenFileDialog1.FileName = OrganDefinitionFilename '& ".CustomOrgan_Hauptwerk_xml"
        Main.OpenFileDialog1.InitialDirectory = customOrgansPath
        Main.OpenFileDialog1.Filter = "CustomOrgan|*.CustomOrgan_Hauptwerk_xml|All files (*.*)|*.*"
        Main.OpenFileDialog1.FilterIndex = 1
        'Main.OpenFileDialog1.RestoreDirectory = True

        If (Main.OpenFileDialog1.ShowDialog() = DialogResult.OK) Then
            file = Main.OpenFileDialog1.FileName
        End If




        Main.RtbCODF.Text = ""
        'Try
        ' Création d'une instance de StreamReader pour permettre la lecture de notre fichier
        Dim monStreamReader As StreamReader = New StreamReader(file)
        ' VERIFIER SI LA 3EME LIGNE = Basilica version ...
        ligne = monStreamReader.ReadLine()
        ligne = monStreamReader.ReadLine()
        ligne = monStreamReader.ReadLine()
        If Left$(ligne, Len("<!-- Basilica version ")) <> "<!-- Basilica version " Then
            MsgBox("You can reload only CODF made with Basilica")
            Exit Sub
        End If

        ' NOMBRE DE CLAVIERS
        ligne = monStreamReader.ReadLine()
        nbrOfManuals = Val(Right$(ligne, 13))
        If nbrOfManuals > 0 Then Main.NumericNbrOfManuals.Value = nbrOfManuals
        If nbrOfManuals > 2 And registered = False Then
            MsgBox("Sorry but unregisterd version of Basilica can only reload organs with 1 or 2 manuals")
            Exit Sub
        End If
        ' VOLUME DES CLAVIERS
        Dim vo As Single
        For vo = 0 To 5
            ligne = monStreamReader.ReadLine()
            If Left(ligne, 11) = "<!-- Volume" Then
                division(vo).volume = Val(Right$(ligne, 6))
                'MsgBox(Right$(ligne, 6))
                'MsgBox("volume = " & division(0).volume)
            End If
        Next
        Main.numericVolumePed.Value = division(0).volume
        Main.NumericVolumeM1.Value = division(1).volume
        Main.NumericVolumeM2.Value = division(2).volume
        Main.NumericVolumeM3.Value = division(3).volume
        Main.NumericVolumeM4.Value = division(4).volume
        Main.NumericVolumeM5.Value = division(5).volume




        '
        ' BOUCLE
        While ligne <> "</Hauptwerk>"
            ligne = monStreamReader.ReadLine()
            If Left(ligne, 8) = "<!--R#ID" Or Left(ligne, 8) = "<!--P#ID" Or Left(ligne, 8) = "<!--C#ID" Then
                knobtype = ligne.Substring(4, 1) ' R pour Rank, P pour PedalRank, C pour Coupler

                Main.RtbCODF.Text += ligne & vbCrLf
                Main.RtbCODF.Text += knobtype & vbCrLf
                knobID = ligne.Substring(9, 2)
                knobID = Val(knobID).ToString
                Main.RtbCODF.Text += knobID & vbCrLf
                ' LIRE KNOBNAME DANS LIGNE SUIVANTE
                ligne = monStreamReader.ReadLine()
                knobName = ligne.Substring(4, Len(ligne) - 7)
                Main.RtbCODF.Text += knobName & vbCrLf
                ' REMPLIR LES KNOBS
                If knobtype = "R" Then
                    pbox = getPictureBox(knobID)
                    If pbox Is Nothing Then
                        ' ne rien faire
                    Else
                        'Main.assignStop(pbox, knobName)
                        Main.assignReloadStop(pbox, knobName, knobtype)
                    End If
                End If
                If knobtype = "P" Then
                    pbox = getPictureBox(knobID)
                    If pbox Is Nothing Then
                        ' ne rien faire
                    Else
                        Main.assignReloadStop(pbox, knobName, knobtype)
                    End If
                End If
                If knobtype = "C" Then
                    pbox = getPictureBox(knobID)
                    If pbox Is Nothing Then
                        ' ne rien faire
                    Else
                        Main.assignCoupler(pbox, knobName)
                    End If
                End If
            End If

        End While
        'Fermeture du StreamReader (attention très important)
        monStreamReader.Close()

        'Catch ex As Exception
        'Code exécuté en cas d'exception
        ' MsgBox("Cannot read " & file)
        'End Try
    End Sub
    Function getPictureBox(ByVal knobID As String)
        Dim kID As Single = Val(knobID)
        Dim pBox As Control
        For Each pBox In Main.TabPage1.Controls
            If TypeOf pBox Is PictureBox Then
                If pBox.Tag = kID Then Return pBox
            End If
        Next
        Return Nothing
    End Function
End Module
